c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine getdata
      character*10  ch1,ch2,ch3,ch4,ch5,ch6,ch7,ch8,ch9,ch10,ch11,ch12

      include 'common.2D'
c
	open(11,file='INDAT')
 
      read(11,*)i_kernel
      read(11,*)i_algorithm
      read(11,*)i_densityFilter  ! Using a shepard filter
      read(11,*)i_viscos
      read(11,*)iBC              !BC
      read(11,*)i_periodicOBs(1)
      read(11,*)i_periodicOBs(2)
      read(11,*)i_periodicOBs(3)
      read(11,*)lattice
      read(11,*)h_SWL 
      read(11,*)B
      read(11,*)gamma
      read(11,*)coef
      read(11,*)eps   ! epsilon XSPH
      read(11,*)rho0
      read(11,*)viscos_val
      read(11,*)visc_wall
      read(11,*)vlx    !Dimensions of container box
      read(11,*)vly    ! vly=0 for 2D
      read(11,*)vlz
      read(11,*)dx
      read(11,*)dy     ! dy=0  for 2D
      read(11,*)dz
      read(11,*)h
      read(11,*)np	
      read(11,*)nb
      read(11,*)nbf
      read(11,*)ivar_dt
      read(11,*) dt
      read(11,*)tmax     ! End of the run(seconds)
      read(11,*)out      ! output every out seconds
      read(11,*)trec_ini ! Initial output 
      read(11,*)dtrec_det !Detailed recording
      read(11,*)t_sta_det
      read(11,*)t_end_det
 
          
       print*
       print*,'Periodicity '
       print*,'i_periodicOBs'
       print*,'X-Direction: ',i_periodicOBs(1)
       print*,'Y-Direction: ',i_periodicOBs(2)
       print*,'Z-Direction: ',i_periodicOBs(3)
       print*
       


       if (np .ge. npar ) then
         write(*,*) 'Number of particles exceeds npar in common!'
         stop
       endif
       if (nb .ge. nb_max ) then
         write(*,*) 'Number of Boundary particles exceeds'
         write(*,*) 'nb_max in common!'
         stop
       endif
       write(*,*) 'np, nb, nbf, ivar_dt, dt ',np,nb,nbf,ivar_dt,dt
       write(*,*) 'h = ',h
       write(*,*) '(dx,dy,dz)=',dx,dy,dz
       write(*,*) B,viscos_val,gamma, rho0
       write(*,*) 'Still Water Depth h_SWL = ',h_SWL

       
       close(11)


       nbfp1=nbf+1
       nbp1=nb+1
       cs0=sqrt(gamma*B/rho0)  !speed of sound at the surface 
       i_gamma = nint(gamma)
       print*,'Integer gamma, i_gamma = nint(gamma) = ',i_gamma
       
       if(i_algorithm.eq.2)then
         kk_verlet = 0  !Initialisation of verlet counter
       end if
       
c      -- Parameters for repulsive force BC --       
       if(lattice.eq.1)then
         vnorm_mass = 1.0
       else if(lattice.eq.2)then
         vnorm_mass = 0.5
       end if
       print*,'lattice    ',lattice
       print*,'vnorm_mass ',vnorm_mass
       if(iBC.eq.1)then
         beta_coef2 = (coef/10.)**2
         beta_coef  = (coef/10.)
         one_over_beta_coef2 = 1.0/beta_coef2
         one_over_beta_coef  = 1.0/beta_coef
       else
         one_over_beta_coef2 = 0.
         one_over_beta_coef  = 0.
       end if

C     Initializing thermal energy
      do i=1,np
        TEp(i)=0.
      enddo    
      
       
      open(13,file='IPART')
             
c     --- Load Particle Position Data ---       
196    format(8e16.8)
       do i=1,np
         read(13,196) xp(i),zp(i),up(i),wp(i),rhop(i),
     +                p(i),pm(i),vorty(i)
                                                                
         if(i_algorithm.eq.2) then ! To be used with Verlet algorithm						  
           xo(i)=xp(i)            
           zo(i)=zp(i)
           rhoo(i)=rhop(i)
           uo(i)=up(i)
           wo(i)=wp(i)
           pr(i) = p(i)/(rhop(i)*rhop(i))
           TEo(i)=TEp(i)
         endif
       
         iflag(i)=1 ! To detect particles inside the container
       
       enddo
       close(13)    
c      ----------------------------------
       
c     ---  Open NORMALS Files ---
      if(iBC.eq.1) then
        open(15,file='NORMALS.init')       
        do i=1,nb
          read(15,*) 
     &    xnb(i),znb(i),
     &    iBP_Pointer_Info(i,1),       !Absolute index BP     
     &    iBP_Pointer_Info(i,2),       !Rank of BP (default=0, reserved for MPI)       
     &    iBP_Pointer_Info(i,3),       !Absolute index of i-1 neighbour BP      
     &    iBP_Pointer_Info(i,4),       !Absolute index of i+1 neighbour BP      
     &    BP_xz_Data(i,1),
     &    BP_xz_Data(i,2)
        enddo
        nstart=nbp1
        close(15)
        call updateNormals_2D(1,nb)
      else
        nstart=1
      endif
      nstart_minus1 = nstart - 1
c     -----------------------------
              
              
c     ------ Load Moving Object Data Files ---------
c
c     - (Note files will be empty for no objects) -
              
              
c     --- The gate ----------------
       open(77,file='gate')
       read(77,*) iopt_gate       
       if(iopt_gate.eq.1) then
         read(77,*) ngate_ini
         read(77,*) ngate_end
         read(77,*) VXgate,VZgate
         read(77,*) tgate
       else
         ngate_ini=1  ! If ngate_ini > ngate_end the loop 
         ngate_end=0  ! in AC doesn't work 
       endif       
       close(77)

       !-- The wavemaker --
       open(66,file='wavemaker')
       read(66,*) iopt_wavemaker       
       if(iopt_wavemaker.eq.1)then
         read(66,*) i_paddleType
         read(66,*) nwavemaker_ini
         read(66,*) nwavemaker_end
         read(66,*) X_PaddleCentre
         read(66,*) X_PaddleStart
         read(66,*) paddle_SWL
         read(66,*) flap_length
         read(66,*) stroke
         read(66,*) twavemaker
         read(66,*) Nfreq
       
         A_wavemaker(0)=0.
         Period(0)=1000*tmax
         phase(0)=0.
         twinitial(0)=twavemaker
       
         do n=1,Nfreq
           read(66,*) A_wavemaker(n)
           read(66,*) Period(n)
           read(66,*) phase(n)
           read(66,*) twinitial(n)
         enddo
         
         do i=1,nb
           xp_ini(i)=xp(i)  ! X initial of two layers of wavemaker
         end do
       
         A_wavemaker(Nfreq+1)=A_wavemaker(Nfreq)
         Period(Nfreq+1)=Period(Nfreq)
         phase(Nfreq+1)=0.
         twinitial(Nfreq+1)=100*tmax
       
         ind_wm=0
         ind1_wm=1
              
       else
       
         nwavemaker_ini=1  ! If nwavemaker_ini > nwavemaker_end the loop 
         nwavemaker_end=0  ! in AC doesn't work 
       
       endif       
       close(66) 
c     -----------------------------

c      ---  Open Raichlen Wedge Input Files --
       open(77,file='Tsunami_Landslide.txt')
       read(77,*) iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1)then
         read(77,*)bslope
         print*
         print*,'-- Opening Raichlen Wedge Input Files --'
         print*
         open(unit=78,file='Benchmark_4_run30.txt')
         read(78,*) i_RBend
         print*,'Number of time measurements, i_RBend ',i_RBend
         do i = 1,i_RBend
           read(78,*)RBtime(i),RBxpos(i)
           RBxpos(i) = RBxpos(i)*0.01   !conversion from cm to m
         end do
         close(78)
         do i = nbf+1,nb
           xp_Wedge_initial(i-nbf) = xp(i)
           zp_Wedge_initial(i-nbf) = zp(i)
         end do
         print*,'Wedge info loaded'
         print*
       end if
       close(77) 
c      ---------------------------------------
       
       if(iopt_gate         .eq.1.or.
     &    iopt_wavemaker    .eq.1.or.
     &    iopt_RaichlenWedge.eq.1) then
         iopt_movingObject = 1
       else
         iopt_movingObject = 0           
       endif
       print*
       print*,'Moving Objects: iopt_movingObject ',iopt_movingObject
       print*

c     --- End of Loading Moving Object Files ---


       !--  Sub-Particle Scale (SPS) Turbulent Stress Terms --     
       !- Smag = (0.12*dp)**2  -
       dp=sqrt(dx*dx + dz*dz)/2.0
       Smag = (0.12*dp)**2 
       twoThirds = 2.0/3.0
       Blin_const = twoThirds*0.0066*dp*dp       
       
       vortmax=0.0
       vortmin=0.0
       densitymax=1000.0
       densitymin=1000.0
C
       write(*,*)' All ',np,' initial points read successfully'
       
       pi = 4.d0*datan(1.d0)
       twopi=2.*pi

C     The extent of all particles is the same but it could be different
c    (1= boundary-boundary; 3= fluid-fluid; 2 boundary-fluid)
 
       print*
       print*,' -- Kernel Information --'
       print*,'Kernel Choice = ',i_kernel
       print*
       
       !Different Kernel Smoothing Lengths
       hh(1)=h
       hh(3)=h
       hh(2)=0.5*(hh(1)+hh(3))

       two_h  = 2.0*h            
       four_h = 4.0*h
       six_h  = 6.0*h            
		 
c 			3D Kernel
c.... coefficients for the spline Kernel W(r)
c.... coefficients for the derivative W_r (r,h) of the spline Kernel
c	(See Liu's Book 2003)	      
       do i=1,3
       
         h2(i)=hh(i)*hh(i)
         fourh2(i)=4.*h2(i)

       
         if (i_kernel.eq.1) then !2D Gaussian 
c                    Wab=      a2*exp(-q2/gauss2)              gaussian kernel
c                             0
c                 W_r=      f1*q*exp(-q2/gauss2)   derivative of gaussian kernel
c                           0
           gauss=1.
           gauss2=gauss*gauss                           
           a1 = 1./pi
           a2(i) = a1/(hh(i)*hh(i))
		 aa = a1/(hh(i)*hh(i)*hh(i))

	     f1(i) = -2.*aa/gauss2       
       
           write(*,*) 'Gaussian kernel',i
           write(*,*) a2(i),f1(i)
       
           !deltap_g=sqrt(2.)/2    
           deltap2=0.5
           Wdeltap=a2(i)*exp(-deltap2/gauss2)
           od_Wdeltap(i)=1./Wdeltap
           write(*,*) od_Wdeltap(i)
       
       
         elseif (i_kernel.eq.2) then !2D Quadratic 
c      		Wab=      b1*(0.25*q*q-q+1)       	quadratic spline-kernel
c		    	 	  0
c       	    W_r=      e1*(0.5*q-1)   derivative of quadratic spline-kernel
c                 	  0
           a1 = 10./(pi*7.)
           a2(i) = a1/(hh(i)*hh(i))
           aa = a1/(hh(i)*hh(i)*hh(i))
              
           b1(i) = 21.*a2(i)/20.
           e1(i) = 21.*aa/20.

           write(*,*) 'Quadratic Kernel',i,aa
           write(*,*) 'b1(i),e1(i) ', b1(i),e1(i)

         elseif(i_kernel.eq.3)then !2D Cubic Spline
       
c                    Wab=      a2*(1-1.5*q*q+0.75*q*q*q)
c                              a24*(2-q)*(2-q)*(2-q)           cubic spline-kernel
c                              0
c                 W_r=      c1*q + d1*q*q
c                           c2*(2-q)**2   derivative of cubic spline-kernel
c                           0

       
           a1 = 10./(pi*7.)
           a2(i) = a1/(hh(i)*hh(i))
           aa = a1/(hh(i)*hh(i)*hh(i))
       
           a24(i) = 0.25*a2(i)
       
           c1(i) = -3.*aa
           d1(i) = 9.*aa/4.
           c2(i) = -3.*aa/4.
       
           write(*,*) 'cubic spline',i,aa,a24(i) 
           write(*,*) c1(i),a2(i),d1(i)

c                 W(Delta_p): used to calculate fab to eliminate the
c                          Tensile Instability. We'll consider
c                 Delta_p=h/1.3 as suggested by Monaghan

           deltap=1./1.5    
           Wdeltap=a2(i)*(1.-1.5*deltap*deltap+
     +        0.75*deltap*deltap*deltap)
           od_Wdeltap(i)=1./Wdeltap
           write(*,*) od_Wdeltap(i)
       
         elseif (i_kernel.eq.5) then  !2D Wendland Quintic
       
       
!		W=Awen*(1-qq/2)**4*(2*qq+1) 0<=r<=2*h

!		dw/dr=Bwen*qq*(1-qq/2)**3. 0<=r<=2*h

!		Awen(i)=7/(4*pi*h3)
!		Bwen(i)=-35/(4*pi*h4)

           Awen(i)=0.557/(h2(i))
           Bwen(i)=-2.7852/(h2(i)*hh(i))
                            
           write(*,*) 'Wendland kernel',i
           write(*,*) Awen(i),Bwen(i)
       
          !deltap_g=1/2	
           deltap=0.5
           Wdeltap=Awen(i)*((1.0-deltap*0.5)**4.0)*(2.0*deltap+1.0)
           od_Wdeltap(i)=1./Wdeltap
           write(*,*) od_Wdeltap(i)
             
         else
           write(*,*) 'i_kernel=',i_kernel,
     +	     ' is not a valid option !!!'
         endif
       enddo
c
c ,,,, viscosity term eta2
c
       eta  = 0.1*h
       eta2 = eta*eta
       
c
c  ... determine xmin,xmax,ymin,ymax,zmin,zmax
c
       xmin = xp(1)
       xmax = xp(1)
       zmin = zp(1)
       zmax = zp(1)
      
       do i=2,nb
         if(xp(i).gt.xmax) xmax=xp(i)
         if(xp(i).lt.xmin) xmin=xp(i)
         if(zp(i).gt.zmax) zmax=zp(i)
         if(zp(i).lt.zmin) zmin=zp(i)
       enddo
       
       !- Limits of domain -    
	    
       xmax_container = xmax 
       xmin_container = xmin 
       zmin_container = zmin
       
       !Periodic correction


       print*
       write(*,*)'xmin_container, xmax_container = ',
     &            xmin_container,xmax_container
       write(*,*)'zmin_container = ',zmin
       print*
       
       do i=nbp1,np
         if(xp(i).gt.xmax) xmax=xp(i)
         if(xp(i).lt.xmin) xmin=xp(i)
         if(zp(i).gt.zmax) zmax=zp(i)
         if(zp(i).lt.zmin) zmin=zp(i)
       enddo
       
c      -- Add small border region to prevent error --
c      -- when calculating icell.. in divide       --
       xmax = xmax + 0.1*h
       xmin = xmin - 0.1*h
       zmax = zmax + 0.1*h
       zmin = zmin - 0.1*h
       
       if(iopt_wavemaker.eq.1.and.i_paddleType.eq.2)then
         !xmin for piston-flap paddle extends further back
         !than initial xmin
         xmin = X_PaddleCentre - 1.5*stroke
       end if
       
       zmax_ini=zmax  ! used to keep moving obstacles 
                      ! inside the initial boundaries
       
       ! To place particles in a convenient place that leave the domain
       xtrash=2.*xmax
       ztrash=0.
c
c  ... determine number of cells
c
       one_over_h  = 1.0/h
       one_over_2h = 1.0/(2.0*h)
       
       ncx = int( (xmax-xmin)*one_over_2h ) + 1
       ncz = int( (zmax-zmin)*one_over_2h ) + 1
       

       nct = ncx*ncz
       
       nct_ini=nct
       
       write(*,*)'xmin, xmax = ',xmin,xmax
       write(*,*)'zmin, zmax = ',zmin,zmax
       
       write(*,*)'ncx/z    = ',ncx,ncz
       write(*,*)'nct= ',nct
        
       return
       end
       
c     ___________________
