c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine step
      include 'common.2D'
	
      dt2 = 0.5*dt

c	Predictor- Corrector Method

c  ...  compute acceleration
c

      if(time*1./1000 .eq. int(time*1./1000) ) then
      !if(itime/1000*1000 .eq. itime) then
        write(*,*) 'In step:   time = ',time,' itime = ',itime
      endif




	call check_limits_2D	!<=========  TEMPORARY
	call ini_divide(2)
	call divide(nbp1,np,2)	

       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1,nb,1)
       endif

      call ac		

      if(ivort_calc.eq.1) ivort_calc = 0



c
c  ... compute corrections to:
c         (a) rate of change of velocity due to
c             (i)  body forces, and
c             (ii) boundary forces
c
c         (b) rate of change of position (free-surface, XSPH)
c
C
      call correct


      if (ivar_dt.eq.1) then
	    call variable_time_step  
	    ddt_p=dt_new
      endif
	

c
c  ... predictor
c

       do i=nstart,np
         xo(i)   = xp(i)
         zo(i)   = zp(i)
         uo(i)   = up(i)
         wo(i)   = wp(i)
         po(i)   = p(i)
         rhoo(i) = rhop(i)
         TEo(i)=TEp(i)

      enddo

      do i=nbp1,np
         xp(i) = xo(i) + dt2*xdot(i)
         zp(i) = zo(i) + dt2*zdot(i)

         up(i) = uo(i) + dt2*udot(i)
         wp(i) = wo(i) + dt2*wdot(i)
      enddo

      do i=nstart,np
         rhop(i) = rhoo(i) + dt2*rdot(i)
c  ...   compute pressure using the equation of state
         p(i) = B * ( (rhop(i)/rho0)**i_gamma - 1.)
c  ...   Compute thermal energy
         TEp(i)=TEo(i)+dt2*TEdot(i)
      enddo

c
c  ...  corrector
c
      call check_limits_2D       !<=========  TEMPORARY
	call ini_divide(2)
	call divide(nbp1,np,2)	

       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1,nb,1)
       endif

      call ac
      call correct



      if (ivar_dt.eq.1) then
	    call variable_time_step 
	    ddt_c=dt_new
           dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
      endif

      do i=nbp1,np

         xp(i) = xo(i) + dt2*xdot(i)
         zp(i) = zo(i) + dt2*zdot(i)

         up(i) = uo(i) + dt2*udot(i) 
         wp(i) = wo(i) + dt2*wdot(i)

      enddo

      do i=nstart,np
         rhop(i) = rhoo(i) + dt2*rdot(i)
         p(i) = B * ( (rhop(i)/rho0)**i_gamma - 1.)
         TEp(i)=TEo(i)+dt2*TEdot(i)
      enddo

      do i=nbp1,np

         xp(i)   = 2.*xp(i) - xo(i)
         zp(i)   = 2.*zp(i) - zo(i)

         up(i)   = 2.*up(i) - uo(i)
         wp(i)   = 2.*wp(i) - wo(i)

      enddo
      do i=nstart,np
         rhop(i) = 2.*rhop(i) - rhoo(i)
         p(i) = B * ( (rhop(i)/rho0)**i_gamma - 1.)
         TEp(i)=2.*TEp(i)-TEo(i)
      enddo

       
      call movingObjects

      end
c