c    "Copyright 2007 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


c       initial data for SPH models                                                                     72

      program SPHYSICSgen_2D
      include 'common.gen2D'

       print*
       write(*,*) '<SPHYSICS>  Copyright (C) <2007>'
       write(*,*) 
     & '<Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, '
       write(*,*) 
     & 'Dr Benedict Rogers, Alejandro Crespo, '
       write(*,*) 
     & 'Muthukumar Narayanaswamy, Dr Shan Zou, and Dr Andrea Panizzo >'
       write(*,*) 'This program comes with ABSOLUTELY NO WARRANTY;    '
       write(*,*) 'This is free software, and you are welcome to      '
       write(*,*) 'redistribute it under conditions stated in         '
       write(*,*) 'the GPL License;                                   '


      print*
      print*,' ---     SPHYSISCgen_2D.F    ---'
      print*,' ---   GENERATING GEOMETRY   ---'
      print*,' ---   Distributed under     ---'
      print*,' ---    the GPL License      ---'
      print*

C     KERNEL
      write(*,*)'Choose KERNEL'

      write(*,*)'Gaussian		   = 1'
      write(*,*)'Quadratic       = 2'
      write(*,*)'Cubic- Spline   = 3'

      write(*,*)'Quartic Wendland= 5'
      read(*,*) i_kernel
      write(*,*) i_kernel

C     ALGORITHM
      write(*,*)'Choose ALGORITHM'
      write(*,*)'Predictor- Corrector = 1'
      write(*,*)'Verlet               = 2'
      read(*,*) i_algorithm
      write(*,*) i_algorithm

c	shepard filter

      write(*,*) ' Do you want to use shepard filter (1=y) ??'
      read(*,*) i_shepard
      write(*,*) i_shepard

c       constants
c
      g=9.81
      rho0=1000.0 !initial density
      pi=4.0*atan(1.0)


c     Initialise periodicity
c
      i_periodicOBs(1) = 0
      i_periodicOBs(2) = 0
      i_periodicOBs(3) = 0


c       define pressure terms

      gamma=7
      expont=1./gamma

c	Viscosity terms
      write(*,*) 'Kind of viscosity  ??'
      write(*,*) ' (1) Artificial (2) Laminar (3) Laminar +SPS'
      read(*,*) i_viscos
      write(*,*) i_viscos

      if (i_viscos.eq.1) then
          write(*,*) 'Alpha  ??'
          read(*,*)  viscos_val
      else
          write(*,*) 'Laminar Viscosity Nu  ??'
          read(*,*)  viscos_val
      endif

      write(*,*) viscos_val

c	pressure terms

      write(*,*) ' Maximum Depth, h_SWL, to calculate B'
      read(*,*)  h_SWL
      write(*,*) h_SWL

      write(*,*) ' Coefficient of Speed of sound ( 10 , 40 ) ??'
      read(*,*) coef
      write(*,*) coef

      coef2=coef*coef

      B=coef2*rho0*g*(h_SWL)/7.0  ! B is estimated using h_SWL and coef
      Co=((B*7.0)/rho0)**.5

      write(*,*) ' B=coef2*rho0*g*(h_SWL)/7.0 =',B
      write(*,*) ' Co=',coef,'*V=',Co

c	boundary type

      write(*,*)'Choose Boundary Type'
      write(*,*)'Monaghan & Kos (1999) = 1'
      write(*,*)'Dalrymple & Knio (2001) = 2'
      read(*,*) IBC
      write(*,*) IBC

      if(iBC.eq.1)then
        print*,' Enter wall viscosity value '
        read(*,*) visc_wall
        print*,' visc_wall = ',visc_wall
      else
        visc_wall = 0.0
      end if

c       Define computational Space

      write(*,*) ' Geometry of the zone'
      write(*,*) ' (1) BOX '
      write(*,*) ' (2) BEACH '
	write(*,*) ' (3) EXTERNALLY FIXED GEOMETRY '
      read(*,*)  i_geometry
      write(*,*) i_geometry

      if (i_geometry.ne.3) then
         write(*,*) 'Fluid Particle Lattice Structure ??'
         print*,' (1) SC; (2) BCC'
         read(*,*) lattice
         write(*,*) 'Lattice Type = ', lattice
         if (lattice.eq.1) then !SC
           vnorm_mass=1.
         else  !BCC
           vnorm_mass=0.5
         endif
      endif

      if (i_geometry.eq.1) then
         call box(g,expont,dx,dy,dz)
      else if (i_geometry.eq.2) then
         call beach(g,expont,dx,dy,dz)
      else if (i_geometry.eq.3) then
         call external_geometry(dx,dy,dz)
      else
         write(*,*) i_geometry,' is not a valid Geometry'
         stop
      endif

      call position_check(dx,dz)

      eps=0.5

      write(*,*)' please input the tmax and out:'
      read(*,*) tmax,out
      write(*,*) tmax,out
      write(*,*)' initial recording time'
      read(*,*) trec_ini
      write(*,*) trec_ini
      write(*,*)' For detailed recording during RUN'
      write(*,*)' step, start, end'
      read(*,*) dtrec_det, t_sta_det, t_end_det
      write(*,*) dtrec_det, t_sta_det, t_end_det

      time=0.
      write(*,*) 'input dt:, Variable time step (1=y)'
      read(*,*) dt,ivar_dt
      write(*,*) dt,ivar_dt

      write(*,*) ' h=coefficient*sqrt(dx*dx+dy*dy+dz*dz)'
      write(*,*) ' Coefficient ??'
      read(*,*)  coefficient
      write(*,*) coefficient




c     ______ Time Step Stability Check
      Cr = 0.1
      Cmax = sqrt(B*gamma/rho0)  !note adjusted formula
      Vmax = max(1.1*Cmax,Cmax)
      dtmax=Cr*min(dx,dz)/Vmax

      print*
      print*,'--- Courant Stability Check ---'
      print*,'Courant No. Cr = ',Cr
      print*,'B    =           ',B
      print*,'Cmax =           ',Cmax
      print*,'dtmax: ',dtmax
      if(dtmax.lt.dt) then
        print*,'dt is TOO big!!!!'
        print*,'suggest: ',dtmax
      endif
      print*
      print*,'--- Viscous Stability Check ---'
      print*,'Kinematic Viscosity',1.0e-6
      print*,'Visc =           ',1.0e-6
      dtmax=Cr*((min(dx,dz))**2)/(101.0*1.0e-6)

      write(*,*) 'dtmax: ',dtmax
      if(dtmax.lt.dt) then
        print*,'dt is TOO big!!!!'
        print*,'suggest: ',dtmax
      endif
      print*
      write(*,*) 'dt: ',dt
      print*




c	___________ File INDAT

      open(11,file='INDAT')

      write(11,*)i_kernel
      write(11,*)i_algorithm
      write(11,*)i_shepard
      write(11,*)i_viscos
      write(11,*)iBC
      write(11,*)i_periodicOBs(1)
      write(11,*)i_periodicOBs(2)
      write(11,*)i_periodicOBs(3)
      write(11,*)lattice
      write(11,*)h_SWL
      write(11,*)B
      write(11,*)gamma
      write(11,*)coef
      write(11,*)eps
      write(11,*)rho0
      write(11,*)viscos_val
      write(11,*)visc_wall
      write(11,*)vlx
      write(11,*)vly
      write(11,*)vlz
      write(11,*)dx
      write(11,*)dy
      write(11,*)dz
      h=coefficient*sqrt(dx*dx+dz*dz)
      write(11,*)h
      write(11,*)np
      write(11,*)nb
      write(11,*)nbf
      write(11,*)ivar_dt
      write(11,*)dt
      write(11,*)tmax
      write(11,*)out
      write(11,*)trec_ini
      write(11,*)dtrec_det
      write(11,*)t_sta_det
      write(11,*)t_end_det
      close(11)

      dpx = dx
      dpy = dy
      dpz = dz
	  
      xb_min = 0.0
      xb_max = vlx
      yb_min = 0.0
      yb_max = vly
      zb_min = 0.0
      zb_max = vlz



c	________ SUBROUTINES FOR DEALING WITH NORMALS (SERIAL Version)

      call normals_Calc_2D
      call normals_FileWrite_2D

      print*


c	__________  File IPART

      open(13,file='IPART')


      vorty=0.

      do i=1,np

        write(13,122) xp(i),zp(i),up(i),wp(i),rhop(i),p(i),pm(i),vorty

      enddo


122   format(8e16.8)
      close(13)


c	__________  File MATLABIN

      open(18,file='matlabin')
      write(18,*) np
      write(18,*) vlx
      write(18,*) vly		!  0 if 2D
      write(18,*) vlz
      write(18,*) out
      write(18,*) nb
      write(18,*) nbf

      close(18)


c	________________________   TO COMPILE

      write(*,*) 'Which compiler is desired? '
      write(*,*) '(1=gfortran, 2=ifort, 3=HP 6.5)'
      read(*,*) i_compile_opt
      write(*,*) i_compile_opt
      if(i_compile_opt.eq.1) then
        call tocompile_gfortran
      elseif(i_compile_opt.eq.2) then
        call tocompile_ifort
      else
        call tocompile_cvf
      end if

      print*,'nbf ',nbf
      print*,'nb  ',nb
      print*,'np  ',np

      stop

      end    ! END OF PROGRAM


c	________________________   SUBROUTINE BOX
c
       subroutine box(g,expont,dx,dy,dz)
       include 'common.gen2D'

       pi=4.*atan(1.)
c       
c     _______ Generate a 2D BOX
c
    
 
         print*
         print*,'--- Generating 2-D Box ---'
         print*
 
         write(*,*) ' Box dimension LX,LZ?'		
         read(*,*) vlx,vlz
         write(*,*) vlx,vlz
         vly=0.
       
         write(*,*) ' Spacing dx,dz?'			
         read(*,*)  dx,dz
         write(*,*) dx,dz
         dy=0.
       
         write(*,*) ' Inclination of floor in X ( beta ) ?? '  
         read(*,*)  beta_deg
         write(*,*) beta_deg
         beta=beta_deg*pi/180
       
         theta=0.
       
         N=nint(vlx/dx)
         M=0		
         L=nint(vlz/dz)

       
      write(*,*) ' Dimension (pixels)', N,M,L
       
      nn=0	! Initial number of particles

      
      call boundaries_left(nn,0,N,M,L,dx,dy,dz,beta,theta)      !x = x1
      call boundaries_right(nn,0,N,M,L,dx,dy,dz,beta,theta)     !x = x2
      call boundaries_bottom(nn,0,N,M,L,dx,dy,dz,beta,theta)    !z = z1


	write(*,*) ' Add wall inside the box (1=y)'
	read(*,*)  iopt_addwall
	write(*,*) iopt_addwall

	do while (iopt_addwall.eq.1)
	   call wall(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another wall inside the box (1=y)'
	   read(*,*)  iopt_addwall
	   write(*,*) iopt_addwall
	enddo


      open(55,file='obstacle')

	write(*,*) ' Add obstacle inside the box (1=y)'
	read(*,*)  iopt_obst
	write(*,*) iopt_obst

	write(55,*) iopt_obst

	do while (iopt_obst.eq.1)
	   call obstacle(nn,dx,dy,dz,beta,theta,iopt_obst)
	   write(*,*) ' Add another obstacle inside the box (1=y)'
	   read(*,*)  iopt_obst
	   write(*,*) iopt_obst
	enddo

	close(55)

	nbf=nn

	write(*,*) 'No of B. Fixed Particles',nbf


	open(66,file='wavemaker')

	write(*,*) ' Add wavemaker inside the box (1=y)'
	read(*,*)  iopt_wavemaker
	write(*,*) iopt_wavemaker

	write(66,*) iopt_wavemaker

	do while (iopt_wavemaker.eq.1)
	   write(*,*) ' Just in Y direction'
	   call wavemaker(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another wavemaker inside the box (1=y)'
	   read(*,*)  iopt_opt
	   write(*,*) iopt_wavemaker
	enddo

	close(66)


      open(77,file='gate')

	write(*,*) ' Add gate inside the box (1=y)'
	read(*,*)  iopt_gate
	write(*,*) iopt_gate

	write(77,*) iopt_gate

	do while (iopt_gate.eq.1)
	   write(*,*) ' Just in Y direction'
	   call gate(nn,dx,dy,dz,beta,theta)
	   write(*,*) ' Add another gate inside the box (1=y)'
	   read(*,*)  iopt_gate
	   write(*,*) iopt_gate
	enddo

	close(77)
C        CHANGED BY MUTHU JULY 31ST
       open(88,file='Tsunami_Landslide.txt')
       iopt_RaichlenWedge=0
       write(88,*)iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1.and.iopt_wavemaker.eq.1)then
         print*,'Cannot have Raichlen Wedge and wavemaker'
         print*,' at the same time'
         stop
       end if
       if(iopt_RaichlenWedge.eq.1)then
          call RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
       endif
       close(88)

	nb=nn

	write(*,*) 'No of B. Particles',nb

	call fluid_particles(nn,N,M,L,dx,dy,dz,expont,g,i_correct_pb,
     +            XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,beta,theta)

	np=nn
	write(*,*) 'No of Particles',np

	if(i_correct_pb.eq.1) then
	   call correct_p_boundaries(expont,g,XXmin,XXmax,YYmin,
     +			             YYmax,ZZmin,ZZmax,dx,dy,dz)
        else
	   call p_boundaries(dx,dy,dz)
	endif

	write(*,*) 'End'
	end


c	________________________   SUBROUTINE BEACH

	subroutine beach(g,expont,dx,dy,dz)
      include 'common.gen2D'

	pi=4.*atan(1.)

             
c
c      |                                                         /
c      |                                                        /
c      |                                                       /
c      |                                                      /
c      |                                                     /
c      |                                                    /
c      |                                                   /
c      |_________________________________________________ /
c      |                                                 /
c      |                                                /
c      |                                               /
c      |          i_water = 1                         /
c      |                                             /
c      |                                            /
c      |                                           /
c      |                                          /    angle beta
c      |_________________________________________/ _ _ _ _ _
c
c      <--------------- vlx1 = N1.dx------------><-- vlx2 = N2.dx -->
c      <------------------------- vlx = N.dx------------------------>
c


c     _________ Generate a BEACH

   

         print*
         print*,'--- Generating 2-D Beach ---'
         print*
         write(*,*) ' Box dimension LX,LZ?'   
         read(*,*)  vlx,vlz
         write(*,*) vlx,vlz
       
         write(*,*) ' Spacing dx,dz?'
         read(*,*)  dx,dz
         write(*,*) dx,dz
       
         write(*,*) ' Length of the flat bed before beach ?? '  
         read(*,*)  vlx1
         write(*,*) vlx1
       
         vlx2=vlx-vlx1
       
         write(*,*) ' Slope (deg) of the inclined plane ( beta ) ?? '  
         read(*,*)  beta_deg
         write(*,*) 'beta_deg ',beta_deg
         beta = beta_deg*pi/180.0
       
         N =nint(vlx/dx)
         N1=nint(vlx1/dx)
         N2=nint(vlx2/dx)
         M=0
         L =nint(vlz/dz)


       
      write(*,*) ' Dimension (pixels)', N,M,L
       
	nn=0	! Initial number of particles


       write(*,*)' If wavemaker will be added, left wall is not needed'
       read(*,*)  iopt_wavemaker
       write(*,*) iopt_wavemaker


c     ______ plane
       
  
      if(iopt_wavemaker.ne.1)then
         call boundaries_left(nn,0,N1,M,L,dx,dy,dz,0.,0.)      !x = x1
	endif

c     _______ tilted plane
       

      call boundaries_right (nn,N1,N,M,L,dx,dy,dz,beta,0.)    !x = x2
      call boundaries_bottom(nn,0,N1,M,L,dx,dy,dz,0.  ,0.)    !flat bottom plane
      call boundaries_bottom(nn,N1,N,M,L,dx,dy,dz,beta,0.)    !inclined beach plane
     

      open(55,file='obstacle')

      write(*,*) ' Add obstacle inside the beach (1=y)'
      read(*,*)  iopt_obst
      write(*,*) iopt_obst

	write(55,*) iopt_obst

	do while (iopt_obst.eq.1)
	   call obstacle(nn,dx,dy,dz,beta,0.,iopt_obst)
	   write(*,*) ' Add another obstacle inside the beach (1=y)'
	   read(*,*)  iopt_obst
	   write(*,*) iopt_obst
	enddo

	close(55)

	nbf=nn

	write(*,*) 'No of B. Fixed Particles',nbf

	open(66,file='wavemaker')

	write(66,*) iopt_wavemaker

      iopt_wavemaker_temp = iopt_wavemaker  !Using temporary variable as iopt_wavemaker is used in fill_part
      do while(iopt_wavemaker_temp.eq.1)
         write(*,*) ' Just in Y direction'
         call wavemaker(nn,dx,dy,dz,beta,0.)
         write(*,*) ' Add another wavemaker For beach (1=y)'
         read(*,*)  iopt_wavemaker_temp
         write(*,*) iopt_wavemaker_temp
      enddo

	close(66)

      open(77,file='gate')

	write(*,*) ' Add gate inside the beach (1=y)'
	read(*,*)  iopt_gate
	write(*,*) iopt_gate

	write(77,*) iopt_gate

	do while (iopt_gate.eq.1)
	   write(*,*) ' Just in Y direction'
	   call gate(nn,dx,dy,dz,beta,0.)
	   write(*,*) ' Add another gate inside the beach (1=y)'
	   read(*,*)  iopt_gate
	   write(*,*) iopt_gate
	enddo

	close(77)
       
      open(88,file='Tsunami_Landslide.txt')
       write(*,*)' Add slidingWedge ?'
       read(*,*)  iopt_RaichlenWedge
       write(*,*) iopt_RaichlenWedge
       write(88,*)iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1.and.iopt_wavemaker.eq.1)then
         print*,'Cannot have Raichlen Wedge and wavemaker'
         print*,' at the same time'
         stop
       end if
       if(iopt_RaichlenWedge.eq.1)then
          call RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
       endif
       close(88)
	
       nb=nn
	write(*,*) 'No of B. Particles',nb

      i_correct_pb=1

c	______ water in the flat region

      write(*,*) ' Add water in the flat region ?? (1=y)'
	read(*,*)    i_water
	write(*,*)   i_water

	if(i_water.eq.1) then
		call fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	    		     g,dx,dy,dz,expont,0.,0.)
      endif

      i_correct_pb=1

c	_______ water in the inclined region

      write(*,*) ' Add water in the inclined region ?? (1=y)'
	read(*,*)    i_water2
	write(*,*)   i_water2

	if(i_water2.eq.1) then
		call fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	    		     g,dx,dy,dz,expont,beta,0.)
     	endif


c	profile of the wave

      write(*,*) ' Add a solitary wave ?? (1=y)'
	read(*,*)    i_wave
	write(*,*)   i_wave

      if (i_wave.eq.1) then
	   call wave(nn,XXmin,XXmax,YYmin,YYmax
     +	    		     ,ZZmin,ZZmax,g,dx,dy,dz,expont)
     	endif

	np=nn
	write(*,*) 'No of Particles',np


	if(i_correct_pb.eq.1) then
	   call correct_p_boundaries(expont,g,XXmin,XXmax,YYmin,
     +			             YYmax,ZZmin,ZZmax,dx,dy,dz)
        else
	   call p_boundaries(dx,dy,dz)
	endif

	return
	end

c	_________________ SUBROUTINE EXTERNAL_GEOMETRY

	subroutine external_geometry(dx,dy,dz)
      include 'common.gen2D'

      i_correct_pb=1
	

	    open(10,file='INI_POS_VEL')
	    read(10,*) np,nb,nbf
	    read(10,*) dx,dz
	    read(10,*) lattice ! (1) SC; (2) BCC

	    if (lattice.eq.1) then !SC
	       vnorm_mass=1.
	    else  !BCC
	       vnorm_mass=0.5
	    endif

	    do n=1,np
	       read(10,*) xp(n),zp(n),up(n),wp(n)
	       call pressure(n,zp(n),dx,0.,dz,expont,g)
	    enddo
	    close(10)

	    XXmax=-1.e+10
	    ZZmax=-1.e+10

	    XXmin=1.e+10
	    ZZmin=1.e+10

	   do im=1,nb ! Recalculate the extent of the medium
	       XXmax=max(XXmax,xp(im))
	       XXmin=min(XXmin,xp(im))
	       ZZmax=max(ZZmax,zp(im))
	       ZZmin=min(ZZmin,zp(im))
	   enddo
	   if(i_correct_pb.eq.1) then
	      call correct_p_boundaries(expont,g,XXmin,XXmax,0.,
     +                                0.,ZZmin,ZZmax,dx,0.,dz)
	   else
	       call p_boundaries(dx,dy,dz)
	   endif

 
      return
	end



c     _________________ SUBROUTINE BOUNDARIES LEFT

      subroutine boundaries_left(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen2D'

      ! Lateral Walls: Left  x = x1
      print*,'Left  wall (x = x1) starts at ',nn+1
      N_start  = N0
      N_finish = N
      L_finish = L

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        !- Inner Layer -
        i=N0
        do j=0,M
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
          enddo
        enddo

	 !- Outer Layer -
 
          do j=0,M
            i=N0
            hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
            Lini=nint(hk/dz)
            do k=Lini,L
              nn=nn+1
              call pos_veloc(nn,(i-0.5)*dx,j*dy,(k-0.5)*dz,0.,0.,0.)
            enddo
          enddo
  
        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        if(i_periodicOBs(2).eq.1)then
          M_start = 0 
          M_finish = M
          
        else
          M_start = 0 
          M_finish = M
        end if
        N_start = 0
        N_finish = 0
        !- One Layer -
        i=N_start
        do j=M_start,M_finish    !In 2-D both are zero --> one column of BPs
          hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)
          L_start=nint(hk/dz)
          do k=L_start,L_finish
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
           !2-D Normals
              if(k.eq.L_start)then
                i_minus1 = nn + 1
                i_plus1  = nn 
              else if(k.eq.L_finish)then
                i_minus1 = nn 
                i_plus1  = nn - 1
              else
                i_minus1 = nn + 1
                i_plus1  = nn - 1
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
          
          enddo
        enddo

      end if     !End of:  if(iBC.eq.1)then

      return
      end

c     _________________ SUBROUTINE BOUNDARIES RIGHT

      subroutine boundaries_right(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen2D'

      ! Lateral Walls: Right  x = x2
      print*,'Right wall (x = x2) starts at ',nn+1
      
      N_start  = N0
      N_finish = N
      L_finish = L
      if(i_periodicOBs(2).eq.1)then
        M_start = 0
        M_finish = M
      else
        M_start = 0 
        M_finish = M
      end if

      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        !- Inner Layer -
        do j=M_start,M_finish
          i=N
          hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
          Lini=nint(hk/dz)
          do k=Lini,L
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
          enddo
        enddo

	 !- Outer Layer -
        
          do j=M_start,M_finish
            i=N
            hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
            Lini=nint(hk/dz)
            do k=Lini,L
              nn=nn+1
              call pos_veloc(nn,(i+0.5)*dx,j*dy,(k-0.5)*dz,0.,0.,0.)
            enddo
          enddo
  
        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
        N_start = N0
        N_finish = N
        !- One Layer -
        i=N_finish
        do j=M_start,M_finish      !In 2-D both are zero --> one column of BPs
          hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)
          L_start=nint(hk/dz)
          do k=L_start,L_finish
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,k*dz,0.,0.,0.)
    
              if(k.eq.L_start)then
                i_minus1 = nn
                i_plus1  = nn + 1 
              else if(k.eq.L_finish)then
                i_minus1 = nn - 1 
                i_plus1  = nn
              else
                i_minus1 = nn - 1
                i_plus1  = nn + 1
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
    
          enddo
        enddo
        
      end if     !End of:  if(iBC.eq.1)then

      return
      end


c     _________________ SUBROUTINE BOUNDARIES BOTTOM

      subroutine boundaries_bottom(NN,N0,N,M,L,dx,dy,dz,beta,theta)
      include 'common.gen2D'



      !- Bottom -
      if(beta.gt.0.0)then
        print*,'Inclined Plane boundary starts at ',nn+1
      else 
        print*,'Bottom boundary starts at         ',nn+1
      end if

      !- One Layer -
      if(i_periodicOBs(2).eq.1)then
        M_start = 0 
        M_finish = M
       
      else
        M_start = 0 
        M_finish = M
      end if
      
      
      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        !- Inner Layer -
        do i=N0+1,N-1     !do i=N0,N   <--- Be careful here not to place particles ontop of each other
          do j=M_start,M_finish
            hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,hk,0.,0.,0.)
          enddo
        enddo

        !- Outer Layer -

          do i=N0,N-1
            do j=0,M
              hk=(i-N0)*dx*tan(beta)+j*dy*tan(theta)
              nn=nn+1
              call pos_veloc(nn,(i+0.5)*dx,j*dy,hk-0.5*dz,0.,0.,0.)
            enddo
          enddo

        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        

        if(i_geometry.eq.2)then   !Sloping Beach
          !N_finish = int((x_beach_start - 0.0)/dx) + 1
          if(beta.gt.0.0)then  !Inclined Plane Section
            N_start = int((vlx1/dx)) + 1
            N_finish = N
          else                     !Flat Bed Section
            N_start = 0
            N_finish = int((vlx1/dx))
          end if
        else
          N_start = 0
          N_finish = N
        end if

        do i=N_start,N_finish
          do j=M_start,M_finish         !do j=0,M

            hk=(i-N_start)*dx*tan(beta)+j*dy*tan(theta)   !BDR
            nn=nn+1
            call pos_veloc(nn,i*dx,j*dy,hk,0.,0.,0.)

              if(i.eq.N_start)then
                i_minus1 = nn
                i_plus1  = nn + 1
              else if(i.eq.N_finish)then
                i_minus1 = nn - 1
                i_plus1  = nn
              else
                i_minus1 = nn - 1
                i_plus1  = nn + 1
              end if
              !-- Normal information - neighbour data for        --
              !-- Repulsive Boundary Particles (BPs)             --
              iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
              iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
  
          enddo
        enddo
        
      end if     !End of:  if(iBC.eq.1)then

      return
      end

c      ____

c	___________________   SUBROUTINE POS_VELOC

	subroutine pos_veloc(nn,xpos,ypos,zpos,uveloc,vveloc,wveloc)
        include 'common.gen2D'

	xp(nn)=xpos
	yp(nn)=ypos
	zp(nn)=zpos
	up(nn)=uveloc
	vp(nn)=vveloc
	wp(nn)=wveloc

	return
	end

C	____

c	____________________ SUBROUTINE FLUID_PARTICLES

	subroutine fluid_particles(nn,N,M,L,dx,dy,dz,expont,g,
     +                              i_correct_pb,XXmin,XXmax,YYmin,
     +                              YYmax,ZZmin,ZZmax,beta,theta)
      include 'common.gen2D'

	write(*,*) 'Initial conditions'
	write(*,*) '1) Set of particles without grid'
	write(*,*) '2) Fill a square shaped region '
	write(*,*) '3) Round shaped drop  '
	write(*,*) '  Which Initial condition ??'
	read(*,*)  initial
	write(*,*) initial
	 
C	 I_CORRECT_PB =   1 bound. pressure will  be corrected
C		          0 boundary pressure will not be corrected


	if(initial.eq.1) then
          i_correct_pb=0
	    call set(nn,g,expont,ZZmin,ZZmax,dx,dy,dz)
	else if(initial.eq.2) then
          write(*,*) ' Correct pressure at boundaries ?? (1=y)'
	    read(*,*)    i_correct_pb
	    write(*,*)   i_correct_pb
	    iopt_fill_part=1
	    do while (iopt_fill_part.eq.1)
	       call fill_part(nn,XXmin,XXmax,YYmin,YYmax
     +                     ,ZZmin,ZZmax,g,dx,dy,dz,expont,beta,theta)
	       write(*,*)'Last Particle',nn
             write(*,*) ' Fill a new region ?? (1=y)'
	       read(*,*)    iopt_fill_part
	       write(*,*)   iopt_fill_part
	    enddo
	else if(initial.eq.3) then
          i_correct_pb=0
	    call drop(nn,g,dx,dy,dz,expont)
	
	else
          write(*,*) initial,' is not a valid I. Condition'
	    stop
	endif

	return

	end

c	_____

c	____________________ SUBROUTINE PRESSURE

      subroutine pressure(nn,ZZmax,dx,dy,dz,expont,g)
      include 'common.gen2D'

      rhop(nn)=rho0*(1.0+rho0*g*(ZZmax-zp(nn))/B)**expont
      p(nn)=B*((rhop(nn)/rho0)**gamma-1.0)
	
	pm(nn)=vnorm_mass*rhop(nn)*dx*dz

      return
	end


c	____________________ SUBROUTINE CORRECT_P_BOUNDARIES

      subroutine correct_p_boundaries (expont,g,XXmin,XXmax,YYmin,
     +			                 YYmax,ZZmin,ZZmax,dx,dy,dz)
      include 'common.gen2D'

	dr=dx*dz


	do nn=1,nb
	   if (xp(nn).le.XXmax. and. xp(nn).ge.XXmin.and.
     +	       yp(nn).le.YYmax. and. yp(nn).ge.YYmin.and.
     +	       Zp(nn).le.ZZmax. and. zp(nn).ge.ZZmin) then

               rhop(nn)=rho0*(1.0+rho0*g*(ZZmax-zp(nn))/B)**expont
	   else
		     rhop(nn)=rho0
	   endif

         p(nn)=B*((rhop(nn)/rho0)**gamma-1.0)

	   if (IBC.eq.1) then
            pm(nn)=rhop(nn)*dr
	   else if (IBC.eq.2) then
            pm(nn)=0.5*rhop(nn)*dr
	   endif

	enddo

      return

	end

c	______

c	____________________ SUBROUTINE P_BOUNDARIES

      subroutine p_boundaries (dx,dy,dz)
      include 'common.gen2D'

	dr=dx*dz


	do nn=1,nb
	   rhop(nn)=rho0
         p(nn)=0.

	   if (IBC.eq.1) then
            pm(nn)=rhop(nn)*dr
	   else if (IBC.eq.2) then
            pm(nn)=0.5*rhop(nn)*dr
	   endif

	enddo

      return

	end

c	______

c	____________________ SUBROUTINE SET

      subroutine set (nn,g,expont,ZZmin,ZZmax,dx,dy,dz)
      include 'common.gen2D'

      write(*,*) ' Number of particles ??'
	read(*,*) number
	write(*,*) number

	do num=1,number
	   nn=nn+1

	   write(*,*) 'Position X,Z'     
	   read(*,*)  xp(nn),zp(nn)
	   write(*,*) xp(nn),zp(nn)  
	   write(*,*) 'Velocity X,Z'     
	   read(*,*)  up(nn),wp(nn)
	   write(*,*) up(nn),wp(nn)	   

         call pressure(nn,zp(nn),dx,dy,dz,expont,g)
	enddo

c	NOTE:For a set of particles without grid B is estimated
c          using the Z coordinate of the box

      return
	end
c	______
c	____________________ SUBROUTINE FILL_PART
       
       subroutine fill_part(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	                     g,dx,dy,dz,expont,beta,theta)
       include 'common.gen2D'
       
       write(*,*) ' Cube containing particles'
       write(*,*) ' XMin, Xmax ??'
       read(*,*) XXmin,XXmax
       write(*,*) XXmin,XXmax
       
       YYmax=0.
       YYmin=0.
        
       write(*,*) ' ZMin, Zmax ??'
       read(*,*) ZZmin,ZZmax
       write(*,*) ZZmin,ZZmax
       
       N_end=nint(XXmax/dx)
       N_ini=nint(XXmin/dx)
       
       Nstepsx=nint((XXmax-XXmin)/dx)+1
       Nstepsy=1
       Nstepsz=nint((ZZmax-ZZmin)/dz)+1
       
       !- Info to stop WPs being placed at same exact location as BPs -
       XXmin_initial = XXmin
       XXmax_initial = XXmax
       ZZmin_initial = ZZmin
       ZZmax_initial = ZZmax
       write(*,*)
       write(*,*)'XXmin_initial ',XXmin_initial
       write(*,*)'XXmax_initial ',XXmax_initial
       write(*,*)'ZZmin_initial ',ZZmin_initial
       write(*,*)'ZZmax_initial ',ZZmax_initial
       write(*,*)
       !---------------------
       
       
       
       XXmin = N_ini*dx
       XXmax = N_end*dx
       
       if(XXmin.gt.XXmin_initial + vnorm_mass*0.5*dx)then
         XXmin = XXmin_initial   !Undoes rounding effect nint above for certain domains
       else if(XXmin.lt.XXmin_initial + 0.99*vnorm_mass*0.5*dx)then
         XXmin = XXmin_initial   !Undoes rounding effect nint above for certain domains
       end if
                  
       M_end=0
       M_ini=0
       
       YYmin=0.
       YYmax=0.
            
       L_end=nint(ZZmax/dz)
       ZZmax=L_end*dz
       L_ini=nint(ZZmin/dz)
       ZZmin=L_ini*dz
       
       if(ZZmax.gt.h_SWL) ZZmax = h_SWL
       
       if (iBC.eq.1) then          
         L_ini = L_ini-1
         ZZmin = (L_ini+0.5)*dz
       endif

                  
       write(*,*) 'Recalculated max and min X ',XXmax,XXmin
       write(*,*) 'Recalculated max and min Y ',YYmax,YYmin
       write(*,*) 'Recalculated max and min Z ',ZZmax,ZZmin
       
       print*
       print*,'iopt_wavemaker ',iopt_wavemaker
       print*,'i_paddleType   ',i_paddleType
       print*,'beta',beta  
       print*    
	    
       write(*,*) ' Npnts x/y/z ', nstepsx,nstepsy,nstepsz
c       if(beta.gt.0)L_end = L_ini + 10  
       
       do i=N_ini,N_end
         do j=1,Nstepsy
         
           hk=(i-N_ini)*dx*tan(beta)+j*dy*tan(theta)   !BDR
           
           if(i.eq.N_ini.and.hk.lt.ZZmin)then
             ZZmin_BC1 = hk
           end if
           
    
           if(iBC.eq.2)then
             if(beta.gt.0.0)hk = hk + 0.5*dz    !Stops water particles being placed ontop of sloping bed particles
             ZZinf=max(ZZmin_BC1,hk)
             L_ini=nint(ZZinf/dz)
             L_end=nint(ZZmax/dz)
           else if(iBC.eq.1)then    !Repulsive force Boundary Condition
             ZZinf=min(ZZmin_BC1,hk)  !MIN ensures continuity of initial particle structure
             L_ini=int(ZZinf/dz)
             L_end=int(ZZmax/dz)
             if(L_end*dz.lt.ZZmax_initial)then
               L_end = L_end + 1         
             end if
           end if
           
            
           do k=L_ini,L_end
              
             x1=XXmin+(i-N_ini)*dx
             y1=0
             z1 = ZZinf+(k-L_ini)*dz
       
             !Check limits for objects
             if(iopt_wavemaker.eq.1)then
               if(i_paddleType.eq.2)then
                 XX_extra =  X_PaddleCentre 
     &               +0.5*(1.0+(z1 - paddle_SWL)/
     &                    (flap_length+paddle_SWL))*stroke
               else
                 XX_extra =  X_PaddleCentre
               end if
               if(x1.gt.XX_extra + 0.5*dx)then
                 i_createParticle = 1
               else
                 i_createParticle = 0
               end if
             else if(iopt_RaichlenWedge.eq.1)then
               if(    x1.ge.block_xstart_point-0.25*dx
     &           .and.x1.le.block_xfinish_point+0.25*dx
     &           .and.z1.le.block_top+0.5*dz)then
                 i_createParticle = 0
               else
                 i_createParticle = 1
               end if
             else
               i_createParticle = 1
             end if
                          
             if(i_createParticle.eq.1)then
             
               if(iBC.eq.2)then   !Dalrymple BC
                   nn=nn+1       
                   call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                   call pressure(nn,ZZmax,dx,dy,dz,expont,g)
               else if(iBC.eq.1)then   !Repulsive BC
                 hk2 = (x1-N_ini*dx)*tan(beta)+j*dy*tan(theta)   
                 if(z1.gt.(1.01*hk2+0.25*dz).and.
     &              z1.lt.1.01*ZZmax.and.
     &              x1.gt.0.99*XXmin_initial.and.
     &              x1.lt.0.99*XXmax_initial+0.5*dx)then
                   nn=nn+1       
                   call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                   call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                 end if
               end if
               
               if (lattice.eq.2) then !BCC	
                
                   x1=XXmin+(i-N_ini+0.5)*dx
                   y1=0.
                   z1=ZZinf+(k-L_ini+0.5)*dz
                   hk2 = (x1-N_ini*dx)*tan(beta)+j*dy*tan(theta)
                   z1=ZZinf+(k-L_ini+0.5)*dz
                   if(x1.le.1.01*XXmax.and.z1.le.1.01*ZZmax) then ! 1.01 to avoid  
cc                     nn=nn+1                                    !roundoff
cc                     call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
cc                     call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                     if(iBC.eq.2)then   !Dalrymple BC
                         nn=nn+1       
                         call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                         call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                     else if(iBC.eq.1)then   !Repulsive BC
                       if(z1.gt.1.01*hk2+0.25*dz.and.
     &                     z1.lt.1.01*ZZmax.and.
     &                     x1.gt.0.99*XXmin_initial.and.
     &                     x1.lt.0.99*XXmax_initial+0.5*dx)then
                         nn=nn+1       
                         call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                         call pressure(nn,ZZmax,dx,dy,dz,expont,g)
                       endif
                     end if
                   endif
                endif
             end if   !End of:   if(i_createParticle.eq.1)then
           enddo
         enddo
       enddo
       
       return       
       end
       
c	______
      
c	______

c	____________________ SUBROUTINE DROP

      subroutine drop(nn,g,dx,dy,dz,expont)
      include 'common.gen2D'


	    write(*,*) ' Center of the drop: Xcen, Zcen ??'  
	    read (*,*)  Xcen, Zcen			
	    write(*,*)  Xcen, Zcen

	    write(*,*) ' Radius'
	    read (*,*)  Radius
	    write(*,*)  Radius

		write(*,*) ' Velocity in X, Z'   
	    read (*,*)  uveloc,wveloc
	    write(*,*)  uveloc,wveloc
          vveloc=0

	    XXmin=Xcen-Radius
	    XXmax=Xcen+Radius
	    YYmin=0
	    YYmax=0
          ZZmin=Zcen-Radius
	    ZZmax=Zcen+Radius

	    N_end=nint(XXmax/dx)
	    N_ini=nint(XXmin/dx)

	    M_end=0
	    M_ini=0

	    L_end=nint(ZZmax/dz)
	    ZZmax=L_end*dz
	    L_ini=nint(ZZmin/dz)
	    ZZmin=L_ini*dz
	    write(*,*) 'Recalculated max and min Z ',ZZmax,ZZmin

			    
	do i=N_ini,N_end
	do j=M_ini,M_end
	do k=L_ini,L_end
	       Xdif=(i+0.5)*dx-Xcen
	       Xdif=Xdif*Xdif
	       Ydif=0
           
	       Zdif=(k+0.5)*dz-Zcen
	       Zdif=Zdif*Zdif

             if(abs(sqrt(Xdif+Ydif+Zdif)).le.radius) then
                nn=nn+1
                call pos_veloc(nn,(i+0.5)*dx,(j+0.5)*dy,
     +			  (k+0.5)*dz,uveloc,vveloc,wveloc)
	          call pressure(nn,ZZmax,dx,dy,dz,expont,g)
	          if (lattice.eq.2) then !BCC
				  nn=nn+1
				  call pos_veloc(nn,(i+1)*dx,(j+1)*dy,(k+1)*dz,
     +			             uveloc,vveloc,wveloc)
				  call pressure(nn,ZZmax,dx,dy,dz,expont,g)
	          endif
             endif
	enddo
	enddo
	enddo

      return

	end

c	______

c	____________________ SUBROUTINE WALL

      subroutine wall(nn,dx,dy,dz,beta,theta)
      include 'common.gen2D'

	write(*,*) ' Wall position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*) Xwall

	write(*,*) ' Wall height ??'
	write(*,*) ' Zwall ??'
	read(*,*) Zwall

	    YYmin=0.
	    YYmax=0.
	    M_ini=0
	    M_end=0
	
	L_end=nint(Zwall/dz)
c	L_ini=0

	write(*,*)M_end,M_ini,L_end,L_ini
	write(*,*)'Begining of wall at ',nn+1

	do j=M_ini,M_end
	    hk=Xwall*tan(beta)+j*dy*tan(theta)
	    L_ini=nint(hk/dz)
	    do k=L_ini,L_end
	         nn=nn+1
	     call pos_veloc(nn,Xwall,j*dy,k*dz,0.,0.,0.)
		 
	       if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.Zwall) then
  	         nn=nn+1
	         call pos_veloc(nn,Xwall+0.5*dx,(j+0.5)*dy,
     +		                   (k+0.5)*dz,0.,0.,0.)
	       endif
	   enddo
	enddo

	write(*,*)'End of wall at ',nn

	return
	end


c	______________________ SUBROUTINE OBSTACLE


      subroutine obstacle(nn,dx,dy,dz,beta,theta,iopt_obst)
      include 'common.gen2D'

	write(*,*) ' Which kind of obstacle'
	write(*,*) ' (1) Solid '
	write(*,*) ' (2) With Solid Walls'
	read(*,*) iopt_kind
	write(*,*) iopt_kind
	
	write(*,*) ' Density of points'
	read(*,*) ndens
	write(*,*) ndens
	dx1=dx/ndens
	dy1=dy/ndens
	dz1=dz/ndens

	write(*,*) ' Cube containing particles'
	write(*,*) ' XMin, Xmax ??'
	read(*,*) XXmin,XXmax
      write(*,*) XXmin,XXmax

	YYmin=0.
	YYmax=0.

	write(*,*) ' ZMin, Zmax ??'
	read(*,*) ZZmin,ZZmax
      write(*,*) ZZmin,ZZmax

	write(*,*) ' slope in X direction??'
	read(*,*) slope
	write(*,*) slope

	slope=slope*pi/180

	if (slope.eq.pi/2) then 	
	  valtan_inv=0
	  Xtop=1.01*XXmax
	else 	
	  valtan_inv =1./tan(slope)
	  kmax=nint(ZZmax/dz1)
	  Xtop=1.01*(XXmax+kmax*dx1*valtan_inv)
	endif

	Nstepsx=nint((XXmax-XXmin)/dx1)+1
	Nstepsy=1
      Nstepsz=nint((ZZmax-ZZmin)/dz1)+1

	write(*,*) 'Npnts x/y/z', nstepsx,nstepsy,nstepsz
	write(*,*) 'Beginning of obstacle at ',nn+1

	N_ini=nint(XXmin/dx1)
	N_end=nint(XXmax/dx1)
      i0=nint(vlx1/dx1)

	M_ini=0
	M_end=0

	do i=N_ini,N_end
	do j=1,Nstepsy

	    hk=(i-i0)*dx1*tan(beta)+j*dy1*tan(theta)
	    ZZinf=max(ZZmin,hk)

	    L_ini=nint(ZZinf/dz1)
	    L_end=nint(ZZmax/dz1)

	    do k=L_ini,L_end
	       if(iopt_kind.eq.1) then
	         x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
	         y1=YYmin+(j-1)*dy1
	         z1=ZZinf+(k-L_ini)*dz1
	         nn=nn+1
	         call pos_veloc(nn,x1,y1,z1,0.,0.,0.)

	         x1=XXmin+(i-N_ini-0.5)*dx1+(k-L_ini)*valtan_inv*dx1
	         y1=YYmin+(j-0.5)*dy1
			 z1=ZZinf+(k-L_ini-0.5)*dz1

	         if(x1.le.Xtop.and.y1.le.1.01*YYmax.and.
     +            z1.le.1.01*ZZmax) then ! 1.01 to avoid the roundoff
	            nn=nn+1
	            call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
	         endif
	       else if(iopt_kind.eq.2) then
				if (i.eq.N_ini.or.i.eq.N_end.or.
     +             j.eq.1.or.j.eq.Nstepsy.or.k.eq.L_end) then
	             x1=XXmin+(i-N_ini)*dx1+(k-L_ini)*valtan_inv*dx1
	             y1=YYmin+(j-1)*dy1
	             z1=ZZinf+(k-L_ini)*dz1
	             nn=nn+1
	             call pos_veloc(nn,x1,y1,z1,0.,0.,0.)
                  endif
	       else
	         write(*,*) ' Not a valid option'
	         stop
	       endif
	  enddo
	enddo	
	enddo

	write(*,*) 'End of obstacle at ',nn

      write(55,*) iopt_obst
      write(55,*) XXmin
	write(55,*) XXmax
      write(55,*) YYmin
      write(55,*) YYmax
      write(55,*) ZZinf
      write(55,*) ZZmax
      write(55,*) slope

	return
	end


c	____________________ SUBROUTINE GATE

      subroutine gate(nn,dx,dy,dz,beta,theta)
      include 'common.gen2D'

	write(*,*) ' Gate position in X coordinates ??'
	write(*,*) ' X Wall ??'
	read(*,*) Xwall
	write(*,*) Xwall
      
	YYmin=0.
	YYmax=0.

	write(*,*) ' Start and end of the gate in Z ??'
	write(*,*) ' ZZMin, ZZmax ??'
	read(*,*) ZZmin,ZZmax
	write(*,*) ZZmin,ZZmax

	write(*,*) ' GATE Velocity  ?? '
	write(*,*) ' Vx,Vz??'
	read(*,*) VXgate,VZgate
	write(*,*) VXgate,VZgate

	write(*,*) ' Initial time to start gate movement??'
	write(*,*) ' tgate ??'
	read(*,*) tgate
	write(*,*) tgate

      M_end=0
      M_ini=0

	L_end=nint(ZZmax/dz)
	L_ini=nint(ZZmin/dz)


	write(*,*) M_end,M_ini,L_end,L_ini
	write(*,*)'Begining of gate at ',nn+1

	ngate_ini=nn+1

	do j=M_ini,M_end
	   do k=L_ini,L_end
	         nn=nn+1
	      call pos_veloc(nn,Xwall,j*dy,k*dz,0.,0.,0.)

	       if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.ZZmax) then
  	        nn=nn+1
	        call pos_veloc(nn,Xwall+0.5*dx,(j+0.5)*dy,
     +                                (k+0.5)*dz,0.,0.,0.)
	       endif
	   enddo
	enddo

	write(*,*)'End of gate at ',nn

	ngate_end=nn

	write(77,*) ngate_ini
	write(77,*) ngate_end
	write(77,*) VXgate,VZgate
      write(77,*) tgate

	return
	end


c	____________________ SUBROUTINE WAVEMAKER

       subroutine wavemaker(nn,dx,dy,dz,beta,theta)
       include 'common.gen2D'
       
       print*
       print*,'--- Generating Wavemaker ---'
       print*
       print*, ' Enter Paddle Type  ??'
       print*,' 1: Piston '
       print*,' 2: Piston-Flap (see Schafer et al. 1996)'
       read(*,*)  i_PaddleType
       print*,    i_PaddleType
       if(i_PaddleType.ne.1.and.i_PaddleType.ne.2)then
         print*,'Incorrect Paddle Type'
         stop
       end if
       
       print*,' Wavemaker Centre position in X coordinates ??'
       print*,' (Generally X_PaddleCentre = 0.5*stroke)'
       read(*,*)  X_PaddleCentre
       print*,    X_PaddleCentre
       
       if(i_paddleType.eq.2)then  !Info Needed for piston-flap paddle
         print*,' Info Needed for piston-flap paddle '
         print*,' Enter paddle Still Water Level (SWL)'
         read(*,*) paddle_SWL
         print*,   paddle_SWL
         print*,' Enter piston-flap flap_length'
         print*,' (distance under the bed of the pivot point' 
         read(*,*) flap_length
         print*,   flap_length
       else
         paddle_SWL  = 0.0
         flap_length = 0.0
       end if
       
       YYmin=0.
       YYmax=0.
        
       write(*,*) ' Start and end of the wavemaker in Z ??'
       write(*,*) ' ZZMin, ZZmax ??'
       read(*,*)  ZZmin,ZZmax
       write(*,*) ZZmin,ZZmax
       
       write(*,*) ' Initial time of wavemaker ??'
       write(*,*) ' twavemaker ??'
       read(*,*)  twavemaker
       write(*,*) twavemaker
       
       write(*,*) ' Number of frequencies  ?? '
       read(*,*)  Nfreq
       write(*,*) Nfreq
       
     
       do n=1,Nfreq
       
         if(i_paddleType.eq.2)then
           write(*,*) ' Wavemaker Stroke = 2*Amplitude   ?? '
           read(*,*)  stroke
           write(*,*) stroke
         else
           write(*,*) ' Amplitude   ?? '
           read(*,*)  A_wavemaker(n)
           write(*,*) A_wavemaker(n)
	     stroke=2*A_wavemaker(n)
         end if

         write(*,*) ' Period  ?? '
         read(*,*)  Period(n)
         write(*,*) Period(n)
     
         write(*,*) ' Phase  ?? '
         read(*,*)  Phase(n)
         write(*,*) Phase(n)
       
         write(*,*) ' twinitial  ?? ' 
         read(*,*)  twinitial(n)
         write(*,*) twinitial(n)

       enddo
                    
       M_start  = 0
       M_finish = 0
       
       L_end=nint(ZZmax/dz)
       L_ini=nint(ZZmin/dz)
       L_start = L_ini
       L_finish = L_end
       
       
       print*,'M_start, M_finish ',M_start, M_finish
       print*,'L_start, L_finish ',L_start, L_finish
       write(*,*)'Start of wavemaker at ',nn+1
       
       nwavemaker_ini=nn+1
       
       X_PaddleStart = 0.5*stroke
       
      if(iBC.eq.2)then        !Dalrymple BC - Fixed Fluid Particles

        do j=M_start,M_finish
          do k=L_start,L_finish
            if(k*dz.gt.ZZmin)then
	        if(i_paddleType.eq.2)then
                XX_extra =  X_PaddleCentre 
     &          +0.5*(1.0+(k*dz - paddle_SWL)/
     &          (flap_length+paddle_SWL))*stroke
              else
                 XX_extra  = X_PaddleCentre
              end if
              nn=nn+1
              call pos_veloc(nn,XX_extra,
     +                             j*dy,k*dz,0.,0.,0.)       
            end if
            if((j+0.5)*dy.le.YYmax.and.(k+0.5)*dz.le.ZZmax) then
              nn=nn+1
              call pos_veloc(nn,XX_extra+0.5*dx,
     &                           (j+0.5)*dy,(k+0.5)*dz,0.,0.,0.)
            endif
              
          enddo
        enddo
        
      else if(iBC.eq.1)then   !Repulsive BC - Repulsive Force Particles with Normals
        
       i=0
       do k=L_start,L_finish
         do j=M_start,M_finish
           !-- Start point is full extension --
           if(i_paddleType.eq.2)then
             XX_extra =  X_PaddleCentre 
     &       +0.5*(1.0+(k*dz - paddle_SWL)/
     &       (flap_length+paddle_SWL))*stroke
           else
             XX_extra  = X_PaddleCentre
           end if
           nn=nn+1
           call pos_veloc(nn,XX_extra,j*dy,k*dz,0.,0.,0.)
            !2-D Normals
            if(k.eq.L_start)then
               i_minus1 = nn + 1
               i_plus1  = nn 
             else if(k.eq.L_finish)then
               i_minus1 = nn 
               i_plus1  = nn - 1
             else
               i_minus1 = nn + 1
               i_plus1  = nn - 1
             end if
             !-- Normal information - neighbour data for        --
             !-- Repulsive Boundary Particles (BPs)             --
             iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
             iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour

         enddo
       enddo
      
      end if     !End of:  if(iBC.eq.1)then
       
      write(*,*)'  End of wavemaker at ',nn
       
       
       nwavemaker_end=nn
       
       Xwavemaker=X_PaddleCentre
       
       write(66,*) i_paddleType
       write(66,*) nwavemaker_ini
       write(66,*) nwavemaker_end
       write(66,*) X_PaddleCentre
       write(66,*) X_PaddleStart
       write(66,*) paddle_SWL
       write(66,*) flap_length
       write(66,*) stroke
       write(66,*) twavemaker
       write(66,*) Nfreq
       
       do n=1,Nfreq       
         write(66,*) A_wavemaker(n)
         write(66,*) Period(n)
         write(66,*) Phase(n)
         write(66,*) twinitial(n)       
       enddo 
    
       return
       end


c     ____
c      ____________________ SUBROUTINE RaichlenWedge_Particles

      subroutine RaichlenWedge_Particles(nn,N1,N,M,dx,dy,dz,beta)
      include 'common.gen2D'

c     This test is based loosely on the experiments of Synolakis et al. (####)

c       -- Read in Wedge parameters --
        write(*,*) 'Enter block-top elevation above SWL'
        read(*,*) bigDelta
        write(*,*) bigDelta
        write(*,*) 'Enter specific Weight'
        read(*,*) specificWeight
        write(*,*) specificWeight
        write(*,*) 'Enter block_length, block_height, block_width'
        read(*,*) block_length, block_height, block_width
        write(*,*) block_length, block_height, block_width
        
        bslope = tan(beta)
        x_beach_start = (int((vlx1/dx))+1)*dx
        shoreline_position = x_beach_start + h_SWL/bslope
        block_top = h_SWL + bigDelta
        block_xstart_point  = shoreline_position - 
     &                        ((block_height - bigDelta)/bslope)
        block_xfinish_point = block_xstart_point + block_length
        block_ystart_point  = 0.5*M*dy - 0.5*block_width
        block_yfinish_point = 0.5*M*dy + 0.5*block_width
        block_zstart_point  = (block_xstart_point-x_beach_start)*bslope
        if(iBC.eq.1)then
          write(*,*) 'Enter block discretisation size'
          read(*,*) dxW, dzW
          write(*,*) dxW, dzW
        else        
          dxW = dx
          dyW = dy
          dzW = dz
        end if
        print*
        print*,'-- Generating Sliding Wedge --'
        print*,'N1 ',N1
        print*,'N1*dx ',N1*dx
        print*,'x_beach_start ',x_beach_start
        print*,'bslope ',bslope
        print*,'h_SWL  ',h_SWL
        print*,'shoreline_position',shoreline_position
        print*,'block_top',block_top
        print*,'block_xstart_point ',block_xstart_point
        print*,'block_xfinish_point',block_xfinish_point
        print*,'block_ystart_point' ,block_ystart_point
        print*,'block_yfinish_point',block_yfinish_point
        print*,'block_zstart_point' ,block_zstart_point
        print*,'dxW',dxW
        print*,'dzW',dzW
        print*

        nn_initial = nn
 
c       -- Block face 3 - x = const = block_xstart_point
        x = block_xstart_point 
        y = block_ystart_point
        z = block_zstart_point
        x = real(int(x/dxW) + 1)*dxW
        M_start  = 0
        M_finish = 0 
        L_start  = int(block_zstart_point /dzW)+1
        L_finish = int(block_top/dzW)+1
        do j = M_start,M_finish
          do k = L_start,L_finish
            nn=nn+1
            y = j*dyW
            z = k*dzW
            call pos_veloc(nn,x,y,z,0.,0.,0.)
            if(iBC.eq.1)then
                if(k.eq.L_start)then
                  i_minus1 = nn 
                  i_plus1  = nn + 1
                else if(k.eq.L_finish)then
                  i_minus1 = nn - 1 
                  i_plus1  = nn
                else
                  i_minus1 = nn - 1
                  i_plus1  = nn + 1
                end if
                !-- Normal information - neighbour data for        --
                !-- Repulsive Boundary Particles (BPs)             --
                iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
                iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            end if
            call pos_veloc(nn,x,y,z,0.,0.,0.)
            if(iBC.ne.1)then
              xtemp = x + 0.5*dxW
              ytemp = y + 0.5*dyW     
              ztemp = z + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
            end if
            !z = z + dzW
          end do
        end do

c       -- Block face 4 - z = const = SWL + bigDelta
        x = block_xstart_point
        y = block_ystart_point
        z = (int(block_top/dzW)+1)*dzW
        M_start  = 0
        M_finish = 0 
        N_start  = int(block_xstart_point /dxW)+1
        N_finish = int(block_xfinish_point/dxW)+1
        do i = N_start,N_finish
          do j = M_start,M_finish
            nn=nn+1
            x = i*dxW
            y = j*dyW
            call pos_veloc(nn,x,y,z,0.,0.,0.)
            if(iBC.eq.1)then
                if(k.eq.N_start)then
                  i_minus1 = nn 
                  i_plus1  = nn + 1
                else if(k.eq.N_finish)then
                  i_minus1 = nn - 1 
                  i_plus1  = nn
                else
                  i_minus1 = nn - 1
                  i_plus1  = nn + 1
                end if
                !-- Normal information - neighbour data for        --
                !-- Repulsive Boundary Particles (BPs)             --
                iBP_Pointer_Info(nn,3) = i_minus1       !i-1 neighbour     
                iBP_Pointer_Info(nn,4) = i_plus1        !i+1 neighbour
            end if
            if(iBC.ne.1)then
              xtemp = x + 0.5*dxW
              ytemp = y + 0.5*dyW    
              ztemp = z + 0.5*dzW
              nn=nn+1
              call pos_veloc(nn,xtemp,ytemp,ztemp,0.,0.,0.)
            end if
          end do
        end do
c       -- End of Wedge

       write(*,*) 'no. of Wedge particles: ',nn
      
      write(88,*)bslope
111   format(3e18.10)
      open(unit=87,
     &  file='Benchmark_4_initialPositions.dat',
     &     status='unknown')
      do i = nn_initial+1,nn
        write(87,111)xp(i),yp(i),zp(i)
      end do
      close(87)

c     -------------------------------

      return
      end

c     ____________________ SUBROUTINE WAVE

      subroutine wave(nn,XXmin,XXmax,YYmin,YYmax,ZZmin,ZZmax,
     +	    		     g,dx,dy,dz,expont)
      include 'common.gen2D'

      write(*,*) ' Cube containing particles'
      write(*,*) ' XMin, Xmax ??'
      read(*,*) XXmin,XXmax
      write(*,*) XXmin,XXmax

      YYMin=0.
	YYmax=0.  

      read(*,*) YYmin,YYmax
      write(*,*) YYmin,YYmax
      write(*,*) ' ZZMin ?? '
      read(*,*) ZZmin
      write(*,*) ZZmin
      
      write(*,*) ' depth ??'
      read(*,*) D
      write(*,*) D
      write(*,*) ' amplitude ??'
      read(*,*) A
      write(*,*) A

      vlong=sqrt(0.75*(D**3)/A)

      write(*,*) ' x0 ??'
      read(*,*) x0
      write(*,*) x0

      Nstepsy=nint((YYmax-YYmin)/dy)+1
	Nstepsy=1

      N_end=nint(XXmax/dx)
      N_ini=nint(XXmin/dx)


      do j=1,Nstepsy	
        do i=N_ini,N_end
       
          x=i*dx
          alt=A/(cosh((x-x0)/vlong)*cosh((x-x0)/vlong))
          vx=alt*(sqrt(9.81/D))
          h=D+alt
          L_ini=nint(ZZmin/dz)
          L_end=nint(h/dz)
          
          do K=L_ini,L_end
            x1=XXmin+(i-N_ini)*dx
            y1=YYmin+(j-1)*dy
            y1=0
            z1=ZZmin+(k-L_ini)*dz
            nn=nn+1
            call pos_veloc(nn,x1,y1,z1,vx,0.,0.)
            call pressure(nn,h,dx,dy,dz,expont,g)
              

              x1=XXmin+(i-N_ini+0.5)*dx
              y1=0
              z1=ZZmin+(k-L_ini+0.5)*dz
              if(x1.le.1.01*XXmax.and.z1.le.1.01*ZZmax) then ! 1.01 to avoid the roundoff
                nn=nn+1
                call pos_veloc(nn,x1,y1,z1,vx,0.,0.)
                call pressure(nn,h,dx,dy,dz,expont,g)
              endif

          enddo
        enddo
      enddo

      return
      end

c     ____

c     ____________________ SUBROUTINE NORMALS_CALC_2D
      
      subroutine normals_Calc_2D

      include 'common.gen2D'
      double precision dxpb1, dxpb2
      
      do i=1,nb
        
        xp_i = xp(i)
        zp_i = zp(i)
        if(iBP_Pointer_Info(i,3).eq.0.and.
     &     iBP_Pointer_Info(i,4).eq.0)then
          if(i.eq.1)then
            i_plus1  = i + 1
            i_minus1 = i
          else if(i.eq.nbf)then   !!Correct This For The Interface Between Two Processes!!
            i_plus1  = i
            i_minus1 = i - 1
          else if(i.eq.nbf+1)then
            i_plus1  = i + 1
            i_minus1 = i
          else if(i.eq.nb)then   !!Correct This For The Interface Between Two Processes!!
            i_plus1  = i
            i_minus1 = i - 1
          else
            i_plus1  = i + 1
            i_minus1 = i - 1
          end if
        else   !Prescribed special neighbours for difficult points
          i_minus1 = iBP_Pointer_Info(i,3)
          i_plus1  = iBP_Pointer_Info(i,4)
        end if
        
        if(i.eq.i_minus1)then
          xp_previous = xp(i) - (xp(i_plus1)-xp(i))
          zp_previous = zp(i) - (zp(i_plus1)-zp(i))
          xp_next = xp(i_plus1)
          zp_next = zp(i_plus1)
        else if(i.eq.i_plus1)then
          xp_previous = xp(i_minus1)
          zp_previous = zp(i_minus1)
          xp_next = xp(i) + (xp(i)-xp(i_minus1))
          zp_next = zp(i) + (zp(i)-zp(i_minus1))
        else
          xp_previous = xp(i_minus1)
          zp_previous = zp(i_minus1)
          xp_next = xp(i_plus1)
          zp_next = zp(i_plus1)
        end if
                
        iBP_Pointer_Info(i,3) = i_minus1
        iBP_Pointer_Info(i,4) = i_plus1
        BP_xz_Data(i,1) = xp(i)
        BP_xz_Data(i,2) = zp(i)
        
        dxn_forward=(xp_next-xp_i)
        dzn_forward=(zp_next-zp_i)
        dxn_back=(xp_i-xp_previous)
        dzn_back=(zp_i-zp_previous)
                
        rbn_back = sqrt(dxn_back*dxn_back + dzn_back*dzn_back)
        rbn_forward = sqrt(dxn_forward*dxn_forward +
     &                     dzn_forward*dzn_forward)
        dzn = dzn_forward + dzn_back
        dxn = dxn_forward + dxn_back
        rb=dxn*dxn+dzn*dzn
        xnb(i)=-dzn/sqrt(rb)
        znb(i)=dxn/sqrt(rb)

      enddo
      
      print*
      print*,'NORMALS calculated'
      print*

      end subroutine  
c     ____

c     ____________________ SUBROUTINE NORMALS_FILEWRITE_2D
c

      subroutine normals_FileWrite_2D
      
      include 'common.gen2D'

      
    
      open(21,file='NORMALS.init')

22    format(2(e16.8,' '),4(i6,' '),4(e16.8,' '))
      do i=1,nb
                
        
        iBP_Pointer_Info(i,1) = i  !Default MPI Rank
        iBP_Pointer_Info(i,2) = 0  !Default MPI Rank
        
        !-- Diagnostic Check --
        if(i.eq.0)then
          print*,'iBP_Pointer_Info(i,1)',
     &            iBP_Pointer_Info(i,1)     
          print*,'iBP_Pointer_Info(i,2)',
     &            iBP_Pointer_Info(i,2)     
          write(*,22) xnb(i),znb(i),
     &    iBP_Pointer_Info(i,1),
     &    iBP_Pointer_Info(i,2),
     &    iBP_Pointer_Info(i,3),
     &    iBP_Pointer_Info(i,4),
     &    BP_xz_Data(i,1),
     &    BP_xz_Data(i,2)
        end if
        !---------------------
        
        write(21,22) xnb(i),znb(i),
     &    iBP_Pointer_Info(i,1),
     &    iBP_Pointer_Info(i,2),
     &    iBP_Pointer_Info(i,3),
     &    iBP_Pointer_Info(i,4),
     &    BP_xz_Data(i,1),
     &    BP_xz_Data(i,2)
        
      enddo
      close(21)
      
      print*
      print*,'NORMALS.init file written'
      print*
      
      end subroutine  
c     ____

c     ____________________ SUBROUTINE PERIODICITY_CHECK
c

      subroutine periodicityCheck(drxp, dryp, drzp,
     &                            xp_i, xp_other,
     &                            yp_i, yp_other,
     &                            zp_i, zp_other)
      
      include 'common.gen2D'

      double precision dxpb1,dxpb2
      double precision dypb1,dypb2
      double precision dzpb1,dzpb2
      
      
c     ---  Subroutine modifies differences in position if periodicity is activated ---      
      
      
        !--- X-Direction Periodicity ---
        if(i_periodicOBs(1).eq.1)then
          if(drxp.gt.6.0*h)then
            dxpb1 = dble(xb_max+dpx)-dble(xp_other)   !xb_max_double-dble(xp_next)
            dxpb2 = dble(xp_i)-dble(xb_min)      !dble(xp_i)-xb_min_double
            drxp = -real(dxpb1+dxpb2)
          else if(drxp.lt.-6.0*h)then
            dxpb1 = dble(xb_max+dpx)-dble(xp_i)    !xb_max_double-dble(xp_i)
            dxpb2 = dble(xp_other)-dble(xb_min)     !dble(xp_next)-xb_min_double
            drxp = real(dxpb1+dxpb2)
          end if
        end if
        !--- Y-Direction Periodicity ---
        if(i_periodicOBs(2).eq.1)then
          if(dryp.gt.6.0*h)then
            dypb1 = dble(yb_max+dpy)-dble(yp_other)   !xb_max_double-dble(xp_next)
            dypb2 = dble(yp_i)-dble(yb_min)      !dble(xp_i)-xb_min_double
            dryp = -real(dypb1+dypb2)
          else if(dryp.lt.-6.0*h)then
            dypb1 = dble(yb_max+dpy)-dble(yp_i)    !xb_max_double-dble(xp_i)
            dypb2 = dble(yp_other)-dble(yb_min)     !dble(xp_next)-xb_min_double
            dryp = real(dypb1+dypb2)
          end if
        end if
        !--- Z-Direction Periodicity ---
        if(i_periodicOBs(3).eq.1)then
          if(drzp.gt.6.0*h)then
            dzpb1 = dble(zb_max+dpz)-dble(zp_other)   !xb_max_double-dble(xp_next)
            dzpb2 = dble(zp_i)-dble(zb_min)      !dble(xp_i)-xb_min_double
            drzp = -real(dzpb1+dzpb2)
          else if(drzp.lt.-6.0*h)then
            dzpb1 = dble(zb_max+dpz)-dble(zp_i)    !xb_max_double-dble(xp_i)
            dzpb2 = dble(zp_other)-dble(zb_min)     !dble(xp_next)-xb_min_double
            drzp = real(dzpb1+dzpb2)
          end if
        end if
      
      end subroutine  


c     ____________________ SUBROUTINE TOCOMPILE_gfortran

      subroutine tocompile_gfortran
      include 'common.gen2D'
      CHARACTER(LEN=10) :: FMT,FMT1
      CHARACTER(LEN=1)  :: TAB
      
      TAB=CHAR(9)
     
      FMT="(A)"
      FMT1="(2A)"
      open(11,file='SPHYSICS.mak')
      write(11,FMT) 'FC=gfortran -O3'
      write(11,FMT) 'OPTIONS= -O3'
      write(11,FMT) 'srcdir=.'
      write(11,FMT) 'idir=../../execs'
      write(11,FMT) 'bakdir=../../execs.bak'
      write(11,FMT) 'objects=energy_2D.o recover_list_2D.o ini_divide_2D
     &.o \'
      write(11,FMT1)TAB,'keep_list_2D.o shepard_2D.o SPHYSICS_2D.o \'
      write(11,FMT1)TAB,'getdata_2D.o check_limits_2D.o poute_2D.o \'                     \'
      write(11,FMT1)TAB,'divide_2D.o variable_time_step_2D.o ac_2D.o \'
      write(11,FMT1)TAB,'movingObjects_2D.o updateNormals_2D.o \'
      write(11,FMT1)TAB,'movingPaddle_2D.o movingWedge_2D.o \'
c         Boundary Conditions
      if (IBC.eq.1) then
             write(11,FMT1)TAB,'self_BC_Monaghan_2D.o \'
             write(11,FMT1)TAB,'celij_BC_Monaghan_2D.o \'
	     write(11,FMT1)TAB,'monaghanBC_2D.o \'
      else
             write(11,FMT1)TAB,'self_BC_Dalrymple_2D.o \'
             write(11,FMT1)TAB,'celij_BC_Dalrymple_2D.o \'
      endif

c         Viscosity
      if (i_viscos.eq.1) then
             write(11,FMT1)TAB,'viscosity_artificial_2D.o \'
      else if (i_viscos.eq.2) then
             write(11,FMT1)TAB,'viscosity_laminar_2D.o \'
      else
             write(11,FMT1)TAB,'viscosity_laminar+SPS_2D.o \'
      endif
		
      if(i_viscos.eq.3) then
            write(11,FMT1)TAB,'correct_SPS_2D.o \'
      else
            write(11,FMT1)TAB,'correct_2D.o \'
      endif
        

c	    Kernels
c	    (1) Gaussian; (2)Quadratic;  (3)Cubic  ; (5) Wendland Quintic
      if (i_kernel.eq.1) then
             write(11,FMT1)TAB,'kernel_gaussian_2D.o \'
      else if (i_kernel.eq.2) then 
             write(11,FMT1)TAB,'kernel_quadratic_2D.o \'
      else if (i_kernel.eq.3) then 
             write(11,FMT1)TAB,'kernel_cubic_2D.o \'  
      else if (i_kernel.eq.5) then
	     write(11,FMT1)TAB,'kernel_wendland5_2D.o \'
      endif

c         Algorithm
      if (i_algorithm.eq.1) then 
           write(11,FMT1)TAB,'step_predictor_corrector_2D.o '
      else
           write(11,FMT1)TAB,'step_verlet_2D.o '
      endif

      write(11,FMT)'#'      
      write(11,FMT)'SPHYSICS_2D: $(objects)'
      write(11,FMT1)TAB,'$(FC) $(OPTIONS) -o SPHYSICS_2D $(objects)'
      write(11,FMT)'#'		
      write(11,FMT1)TAB,'if [ -d $(bakdir) ]; then \'
      write(11,FMT1)TAB,'echo "execs.bak Directory Exists"; else \'
      write(11,FMT1)TAB,'mkdir $(bakdir); \'
      write(11,FMT1)TAB,'echo "execs.bak Directory Created"; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#' 		
      write(11,FMT1)TAB,'if [ -d $(idir) ]; then \'
      write(11,FMT1)TAB,'echo "execs Directory Exists"; else \'
      write(11,FMT1)TAB,'mkdir $(idir); \'
      write(11,FMT1)TAB,'echo "execs Directory Created"; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#' 
      write(11,FMT1)TAB,'-if [ -f $(idir)/SPHYSICS_2D ]; then \'
      write(11,FMT1)TAB,'mv $(idir)/SPHYSICS_2D $(bakdir)/; \'
      write(11,FMT1)TAB,'echo Old SPHYSICS_2D moved to execs.bak
     & from execs; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#'	
      write(11,FMT1)TAB,'mv SPHYSICS_2D $(idir)'
      write(11,FMT1)TAB,'echo New SPHYSICS_2D moved to execs'
      write(11,FMT)'#'
      write(11,FMT)'clean:'
      write(11,FMT1)TAB,'rm *.o'
      write(11,FMT1)TAB,'rm *~' 
       
      close(11)
      return
      end	
c     ____
  

c     ____________________ SUBROUTINE TOCOMPILE_gfortran

      subroutine tocompile_ifort
      include 'common.gen2D'
      CHARACTER(LEN=10) :: FMT,FMT1
      CHARACTER(LEN=1)  :: TAB
      
      TAB=CHAR(9)
     
      FMT="(A)"
      FMT1="(2A)"
      open(11,file='SPHYSICS.mak')
      write(11,FMT) 'FC=ifort'
      write(11,FMT) 'OPTIONS= -O3'
      write(11,FMT) 'srcdir=.'
      write(11,FMT) 'idir=../../execs'
      write(11,FMT) 'bakdir=../../execs.bak'
      write(11,FMT) 'objects=energy_2D.o recover_list_2D.o ini_divide_2D
     &.o \'
      write(11,FMT1)TAB,'keep_list_2D.o shepard_2D.o SPHYSICS_2D.o \'
      write(11,FMT1)TAB,'getdata_2D.o check_limits_2D.o poute_2D.o \'                     \'
      write(11,FMT1)TAB,'divide_2D.o variable_time_step_2D.o ac_2D.o \'
      write(11,FMT1)TAB,'movingObjects_2D.o updateNormals_2D.o \'
      write(11,FMT1)TAB,'movingPaddle_2D.o movingWedge_2D.o \'
c         Boundary Conditions
      if (IBC.eq.1) then
             write(11,FMT1)TAB,'self_BC_Monaghan_2D.o \'
             write(11,FMT1)TAB,'celij_BC_Monaghan_2D.o \'
	     write(11,FMT1)TAB,'monaghanBC_2D.o \'
      else
             write(11,FMT1)TAB,'self_BC_Dalrymple_2D.o \'
             write(11,FMT1)TAB,'celij_BC_Dalrymple_2D.o \'
      endif

c         Viscosity
      if (i_viscos.eq.1) then
             write(11,FMT1)TAB,'viscosity_artificial_2D.o \'
      else if (i_viscos.eq.2) then
             write(11,FMT1)TAB,'viscosity_laminar_2D.o \'
      else
             write(11,FMT1)TAB,'viscosity_laminar+SPS_2D.o \'
      endif
		
      if(i_viscos.eq.3) then
            write(11,FMT1)TAB,'correct_SPS_2D.o \'
      else
            write(11,FMT1)TAB,'correct_2D.o \'
      endif
        

c	    Kernels
c	    (1) Gaussian; (2)Quadratic;  (3)Cubic  ; (5) Wendland Quintic
      if (i_kernel.eq.1) then
             write(11,FMT1)TAB,'kernel_gaussian_2D.o \'
      else if (i_kernel.eq.2) then 
             write(11,FMT1)TAB,'kernel_quadratic_2D.o \'
      else if (i_kernel.eq.3) then 
             write(11,FMT1)TAB,'kernel_cubic_2D.o \'  
      else if (i_kernel.eq.5) then
	     write(11,FMT1)TAB,'kernel_wendland5_2D.o \'
      endif

c         Algorithm
      if (i_algorithm.eq.1) then 
           write(11,FMT1)TAB,'step_predictor_corrector_2D.o '
      else
           write(11,FMT1)TAB,'step_verlet_2D.o '
      endif

      write(11,FMT)'#'      
      write(11,FMT)'SPHYSICS_2D: $(objects)'
      write(11,FMT1)TAB,'$(FC) $(OPTIONS) -o SPHYSICS_2D $(objects)'
      write(11,FMT)'#'		
      write(11,FMT1)TAB,'if [ -d $(bakdir) ]; then \'
      write(11,FMT1)TAB,'echo "execs.bak Directory Exists"; else \'
      write(11,FMT1)TAB,'mkdir $(bakdir); \'
      write(11,FMT1)TAB,'echo "execs.bak Directory Created"; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#' 		
      write(11,FMT1)TAB,'if [ -d $(idir) ]; then \'
      write(11,FMT1)TAB,'echo "execs Directory Exists"; else \'
      write(11,FMT1)TAB,'mkdir $(idir); \'
      write(11,FMT1)TAB,'echo "execs Directory Created"; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#' 
      write(11,FMT1)TAB,'-if [ -f $(idir)/SPHYSICS_2D ]; then \'
      write(11,FMT1)TAB,'mv $(idir)/SPHYSICS_2D $(bakdir)/; \'
      write(11,FMT1)TAB,'echo Old SPHYSICS_2D moved to execs.bak
     & from execs; \'
      write(11,FMT1)TAB,'fi'
      write(11,FMT)'#'	
      write(11,FMT1)TAB,'mv SPHYSICS_2D $(idir)'
      write(11,FMT1)TAB,'echo New SPHYSICS_2D moved to execs'
      write(11,FMT)'#'
      write(11,FMT)'clean:'
      write(11,FMT1)TAB,'rm *.o'
      write(11,FMT1)TAB,'rm *~' 
       
      close(11)
      return
      end	
c     ____
  


c     ____________________ SUBROUTINE TOCOMPILE_WINDOWS


      subroutine tocompile_cvf
      include 'common.gen2D'

      open(11,file='SPHYSICS.mak')
      write(11,10) 
      write(11,11)
      write(11,12)
	
10    format('OUTDIR=..\..\execs')
11    format('INTDIR=..\..\execs')
12    format('ALL : "$(OUTDIR)\SPHYSICS_2D.exe"')
      write(11,13)
13    format('"$(OUTDIR)" :')
      write(11,*) '   if not exist 
     +"$(OUTDIR)/$(NULL)" mkdir "$(OUTDIR)"'	
      write(11,14)
14    format('F90=df.exe')
      write(11,15)
15    format('F90_PROJ=/compile_only /nologo
     + /warn:nofileopt /module:"..\..\execs/" /object:"..\..\execs/"')
      write(11,16)
16    format ('F90_OBJS=..\..\execs/')
      write(11,17)
17    format('.SUFFIXES: .fpp')
      write(11,18)
18    format('.f{$(F90_OBJS)}.obj:')
      write(11,*) '  $(F90) $(F90_PROJ) $<'
      write(11,19) 
19    format('LINK32=link.exe')
      write(11,20)
20    format('LINK32_FLAGS=kernel32.lib /nologo 
     +/subsystem:console /incremental:no /pdb:"$(OUTDIR)
     +\SPHYSICS_2D.pdb" /machine:I386 /out:"$(OUTDIR)\SPHYSICS_2D.exe"')
      write(11,21) 
21    format('LINK32_OBJS= \')

c     Including general files

      write(11,*) '    "$(INTDIR)\energy_2D.obj" \'
      write(11,*) '    "$(INTDIR)\recover_list_2D.obj" \'
      write(11,*) '    "$(INTDIR)\ini_divide_2D.obj" \'
      write(11,*) '    "$(INTDIR)\keep_list_2D.obj" \'
      write(11,*) '    "$(INTDIR)\shepard_2D.obj" \'
      write(11,*) '    "$(INTDIR)\SPHYSICS_2D.obj" \'
      write(11,*) '    "$(INTDIR)\getdata_2D.obj" \'
      write(11,*) '    "$(INTDIR)\check_limits_2D.obj" \'
      write(11,*) '    "$(INTDIR)\poute_2D.obj" \'
      write(11,*) '    "$(INTDIR)\divide_2D.obj" \'
      write(11,*) '    "$(INTDIR)\variable_time_step_2D.obj" \'
      write(11,*) '    "$(INTDIR)\ac_2D.obj" \'
      write(11,*) '    "$(INTDIR)\movingObjects_2D.obj" \'
      write(11,*) '    "$(INTDIR)\movingPaddle_2D.obj" \'
      write(11,*) '    "$(INTDIR)\movingWedge_2D.obj" \'
      write(11,*) '    "$(INTDIR)\updateNormals_2D.obj" \'


c         Boundary Conditions
      if (IBC.eq.1) then
             write(11,*) '    "$(INTDIR)\self_BC_Monaghan_2D.obj" \'
             write(11,*) '    "$(INTDIR)\celij_BC_Monaghan_2D.obj" \'
	       write(11,*) '    "$(INTDIR)\MonaghanBC_2D.obj" \'
      else
             write(11,*) '    "$(INTDIR)\self_BC_Dalrymple_2D.obj" \'
             write(11,*) '    "$(INTDIR)\celij_BC_Dalrymple_2D.obj" \'
      endif

c         Viscos   
      if (i_viscos.eq.1) then 
         write(11,*) '    "$(INTDIR)\viscosity_artificial_2D.obj" \'
      else if (i_viscos.eq.2) then
             write(11,*) '    "$(INTDIR)\viscosity_laminar_2D.obj" \'
      else
            write(11,*) '    "$(INTDIR)\viscosity_laminar+SPS_2D.obj" \'
      endif

c         Corrections
      if (i_viscos.ne.3) then 
             write(11,*) '    "$(INTDIR)\correct_2D.obj" \'
      else if (i_viscos.eq.3) then
             write(11,*) '    "$(INTDIR)\correct_SPS_2D.obj" \'
      endif

c	    Kernels
c	    (1) Gaussian; (2)Quadratic;  (3)Cubic  ; (5) Wendland Quintic
      
      if (i_kernel.eq.1) then
             write(11,*) '    "$(INTDIR)\kernel_gaussian_2D.obj" \'
      else if (i_kernel.eq.2) then 
          write(11,*) '    "$(INTDIR)\kernel_quadratic_2D.obj" \'
      else if (i_kernel.eq.3) then 
             write(11,*) '    "$(INTDIR)\kernel_cubic_2D.obj" \' 
      else if (i_kernel.eq.5) then
             write(11,*) '    "$(INTDIR)\kernel_wendland5_2D.obj" \'
      endif

c         Algorithm
      if (i_algorithm.eq.1) then 
          write(11,*) '    "$(INTDIR)\step_predictor_corrector_2D.obj" '
      else
           write(11,*) '    "$(INTDIR)\step_verlet_2D.obj" '
      endif



 

      write(11,25)
25	format('"$(OUTDIR)\SPHYSICS_2D.exe" : "$(OUTDIR)" 
     +$(DEF_FILE) $(LINK32_OBJS)')
      write(11,26) 
26	format('   $(LINK32) @<<')
	write(11,27)
27	format(' $(LINK32_FLAGS) $(LINK32_OBJS)')
	write(11,28) 
28	format('<<')
	write(11,29) 
29    format('!IF "$(NO_EXTERNAL_DEPS)" != "1"')
	write(11,30) 
30    format('!IF EXISTS("SPHYSICS_2D.dep")')
	write(11,31) 
31    format('!INCLUDE "SPHYSICS_2D.dep"')
      write(11,32) 
32    format('!ELSE')
      write(11,33)
33	format('!MESSAGE Warning: cannot find "SPHYSICS_2D.dep"')
      write(11,34)
      write(11,34)
34	format('!ENDIF')

c	General files 
	write(11,1)
1	format(	'SOURCE=.\SPHYSICS_2D.f')
	write(11,2)
2	format('"$(INTDIR)\SPHYSICS_2D.obj" : $(SOURCE) "$(INTDIR)"') 
	write(11,35)
35	format(	'SOURCE=.\energy_2D.f')
	write(11,36)
36	format('"$(INTDIR)\energy_2D.obj" : $(SOURCE) "$(INTDIR)"')
      write(11,37) 
37	format('SOURCE=.\recover_list_2D.f')
	write(11,38) 
38	format('"$(INTDIR)\recover_list_2D.obj" : $(SOURCE) "$(INTDIR)"')
      write(11,41)
41	format(	'SOURCE=.\ini_divide_2D.f')
	write(11,42)
42	format('"$(INTDIR)\ini_divide_2D.obj" : $(SOURCE) "$(INTDIR)"')
      write(11,43) 
43	format('SOURCE=.\keep_list_2D.f')
	write(11,44) 
44	format('"$(INTDIR)\keep_list_2D.obj" : $(SOURCE) "$(INTDIR)"')
      write(11,437) 
437	format('SOURCE=.\shepard_2D.f')
	write(11,438) 
438	format('"$(INTDIR)\shepard_2D.obj" : $(SOURCE) "$(INTDIR)"')


   
          write(11,47) 
47	    format('SOURCE=.\getdata_2D.f')
	    write(11,48) 
48	    format('"$(INTDIR)\getdata_2D.obj" : $(SOURCE) "$(INTDIR)"')
	    write(11,247) 
247	    format('SOURCE=.\check_limits_2D.f')
		write(11,248)
248	    format('"$(INTDIR)\check_limits_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
          write(11,46) 
46	    format('"$(INTDIR)\variable_time_step_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		write(11,3)
3	    format(	'SOURCE=.\divide_2D.f')
	    write(11,4)
4	    format('"$(INTDIR)\divide_2D.obj" : $(SOURCE) "$(INTDIR)"')
		write(11,49) 
49		format('SOURCE=.\poute_2D.f')
		write(11,50) 
50		format('"$(INTDIR)\poute 2D.obj" : $(SOURCE) "$(INTDIR)"')
		write(11,458) 
458	    format('SOURCE=.\updateNormals_2D.f')
          write(11,459) 
459	    format('"$(INTDIR)\updateNormals_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		write(11,81) 
81		format('SOURCE=.\ac_2D.f')
		write(11,82) 
82		format('"$(INTDIR)\ac_2D.obj" : $(SOURCE) "$(INTDIR)"') 

	    write(11,677) 
677	    format('SOURCE=.\movingObjects_2D.f')
          write(11,678) 
678		format('"$(INTDIR)\movingObjects_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')

	write(11,679)
679    format(	'SOURCE=.\movingPaddle_2D.f')
	write(11,680)
680    format('"$(INTDIR)\movingPaddle_2D.obj" : $(SOURCE) "$(INTDIR)"') 

	write(11,681)
681    format(	'SOURCE=.\movingWedge_2D.f')
	write(11,682)
682    format('"$(INTDIR)\movingWedge_2D.obj" : $(SOURCE) "$(INTDIR)"')








c         Boundary Conditions
	    if (IBC.eq.1) then
			write(11,55) 
55			format('SOURCE=.\self_BC_Monaghan_2D.f')
			write(11,56) 
56			format('"$(INTDIR)\self_BC_Monaghan_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
			write(11,57) 
57			format('SOURCE=.\celij_BC_Monaghan_2D.f')
			write(11,58) 
58			format('"$(INTDIR)\celij_BC_Monaghan_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		else
			write(11,59) 
59			format('SOURCE=.\self_BC_Dalrymple_2D.f')
			write(11,60) 
60			format('"$(INTDIR)\self_BC_Dalrymple_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
			write(11,61) 
61			format('SOURCE=.\celij_BC_Dalrymple_2D.f')
			write(11,62) 
62			format('"$(INTDIR)\celij_BC_Dalrymple_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"') 
		endif

c         Viscosity
	    if (i_viscos.eq.1) then 
		   write(11,63) 
63		   format('SOURCE=.\viscosity_artificial_2D.f')
		   write(11,64) 
64		   format('"$(INTDIR)\viscosity_artificial_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
          elseif (i_viscos.eq.2) then
             write(11,65) 
65		   format('SOURCE=.\viscosity_laminar_2D.f')
		   write(11,66) 
66		   format('"$(INTDIR)\viscosity_laminar_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		else
             write(11,67) 
67		   format('SOURCE=.\viscosity_laminar+SPS_2D.f')
		   write(11,68) 
68		   format('"$(INTDIR)\viscosity_laminar+SPS_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		endif

c         Corrections
	    if (i_viscos.ne.3) then 
		   write(11,53) 
53		   format('SOURCE=.\correct_2D.f')
		   write(11,54) 
54		   format('"$(INTDIR)\correct_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
	    else
		   write(11,267) 
267		   format('SOURCE=.\correct_SPS_2D.f')
		   write(11,268) 
268		   format('"$(INTDIR)\correct_SPS_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
	    endif

c	    Kernels
c	    (1) Gaussian; (2)Quadratic;  (3)Cubic  ; (5) Wendland Quintic
	    if (i_kernel.eq.2) then 
	       write(11,69) 
69		   format('SOURCE=.\kernel_quadratic_2D.f')
		   write(11,70) 
70		   format('"$(INTDIR)\kernel_quadratic_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
		else if (i_kernel.eq.3) then 
	       write(11,71) 
71		   format('SOURCE=.\kernel_cubic_2D.f')
		   write(11,72) 
72		   format('"$(INTDIR)\kernel_cubic_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
	    else if (i_kernel.eq.1) then 
	       write(11,73) 
73		   format('SOURCE=.\kernel_gaussian_2D.f')
		   write(11,74) 
74		   format('"$(INTDIR)\kernel_gaussian_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
	    else if (i_kernel.eq.5) then 
	       write(11,73) 
75		   format('SOURCE=.\kernel_wendland5_2D.f')
		   write(11,74) 
76		   format('"$(INTDIR)\kernel_wendland5_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"')
       	endif

c         Algorithm
	    if (i_algorithm.eq.1) then 
	       write(11,77) 
77		   format('SOURCE=.\step_predictor_corrector_2D.f')
		   write(11,78) 
78		   format('"$(INTDIR)\step_predictor_corrector_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"') 
		else
		   write(11,79) 
79		   format('SOURCE=.\step_verlet_2D.f')
		   write(11,80) 
80		   format('"$(INTDIR)\step_verlet_2D.obj" : 
     +$(SOURCE) "$(INTDIR)"') 
		endif


 	close(11)


	return
	end
       
C-------SUBROUTINE TO ENSURE THAT PARTICLES ARE NOT TOO
C       CLOSE TO EACH OTHER
c
c     For Repulsive Boundary Force BC (iBC.eq.1), Boundary Particles
c     can be on top of each other
c     However, for Dalrymple BC (iBC.eq.2) particles ontop of each
c     will cause the code to crash
c
c

      subroutine position_check(dx,dz)
      include 'common.gen2D'

      dx_thresh=0.10*dx
      dz_thresh=0.10*dz
      
      print*
      print*,'-- Checking particles initial Positions --'
      print*,'dx, dz ',dx, dz
      print*,'dx_thresh ',dx_thresh
      print*,'dz_thresh ',dz_thresh

      do ii=1,np-1
        do jj=ii+1,np
          
          delta_x=abs(xp(jj)-xp(ii))
          delta_z=abs(zp(jj)-zp(ii))
          if(delta_x.lt.dx_thresh.and.delta_z.lt.dz_thresh) then
            print*
            write(*,*) 'WARNING: The following Particles are closer'
            write(*,*) 'than dx_thresh or dz_thresh', ii,jj
            print*,'xp(ii), zp(ii) ',xp(ii), zp(ii)
            print*,'xp(jj), zp(jj) ',xp(ii), zp(jj)
            if(delta_x.lt.0.1*dx_thresh.and.
     &         delta_z.lt.0.1*dz_thresh)then
              if((iBC.eq.1.and.(ii.gt.nb.or.jj.gt.nb)).or.iBC.eq.2)then
                print*,'Particles are too close and will cause code'
                print*,'code to crash'
c                stop
              end if              
            end if
          endif
        
        enddo
      enddo

      print*,'--> Particle Positions Okay'
      print*

      return
      end
